/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10/src/cmp/cmpmain.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmpmain.eclh"
/*      function definition for COMPILE-FILE-PATHNAME                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4024compile_file_pathname(cl_narg narg, cl_object v1name, ...)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2output_file;
  cl_object v3type;
  cl_object v4type_supplied_p;
  cl_object v5system_p;
  ecl_va_list args; ecl_va_start(args,v1name,narg,1);
  {
   cl_object keyvars[6];
   cl_parse_key(args,3,L4024compile_file_pathnamekeys,keyvars,NULL,TRUE);
   ecl_va_end(args);
   if (Null(keyvars[3])) {
    v2output_file = ECL_T;
   } else {
    v2output_file = keyvars[0];
   }
   v3type = keyvars[1];
   v4type_supplied_p = keyvars[4];
   v5system_p = keyvars[2];
  }
  v1name = cl_pathname(v1name);
  {
   cl_object v6format;
   cl_object v7extension;
   v6format = ECL_NIL;
   v7extension = ECL_NIL;
   if ((v4type_supplied_p)!=ECL_NIL) { goto L6; }
   if (Null(v5system_p)) { goto L9; }
   v3type = ECL_SYM("OBJECT",1312);
   goto L8;
L9:;
   v3type = VV[0];
L8:;
L6:;
   if (!((v3type)==(VV[2]))) { goto L17; }
   goto L14;
   goto L15;
L17:;
   goto L15;
L15:;
   if (!((v3type)==(VV[3]))) { goto L12; }
   goto L13;
L14:;
L13:;
   v6format = ecl_symbol_value(VV[5]);
   goto L11;
L12:;
   if (!((v3type)==(VV[7]))) { goto L26; }
   goto L23;
   goto L24;
L26:;
   goto L24;
L24:;
   if (!((v3type)==(VV[8]))) { goto L30; }
   goto L23;
   goto L28;
L30:;
   goto L28;
L28:;
   if (!((v3type)==(VV[10]))) { goto L21; }
   goto L22;
L23:;
L22:;
   v6format = ecl_symbol_value(VV[12]);
   goto L11;
L21:;
   if (!((v3type)==(VV[13]))) { goto L34; }
   v7extension = VV[14];
   goto L11;
L34:;
   if (!((v3type)==(VV[15]))) { goto L37; }
   v7extension = VV[16];
   goto L11;
L37:;
   if (!((v3type)==(VV[17]))) { goto L40; }
   {
    cl_object v8;
    cl_object v9;
    cl_object v10;
    v8 = ecl_symbol_value(ECL_SYM("*FEATURES*",36));
    v9 = VV[18];
    v10 = v8;
    if (Null(ecl_memql(v9,v10))) { goto L43; }
   }
   v7extension = VV[19];
   goto L42;
L43:;
   v7extension = VV[20];
L42:;
   goto L11;
L40:;
   if (!((v3type)==(VV[21]))) { goto L48; }
   v7extension = VV[22];
   goto L11;
L48:;
   if (!((v3type)==(ECL_SYM("OBJECT",1312)))) { goto L51; }
   v7extension = ecl_symbol_value(VV[23]);
   goto L11;
L51:;
   if (!((v3type)==(VV[24]))) { goto L54; }
   v6format = ecl_symbol_value(VV[25]);
   goto L11;
L54:;
   if (!((v3type)==(VV[26]))) { goto L57; }
   v6format = VV[27];
   goto L11;
L57:;
   if (!((v3type)==(VV[0]))) { goto L64; }
   goto L61;
   goto L62;
L64:;
   goto L62;
L62:;
   if (!((v3type)==(VV[29]))) { goto L11; }
   goto L60;
L61:;
L60:;
   v7extension = VV[31];
L11:;
   if (!(ecl_eql(v2output_file,ECL_T))) { goto L72; }
   goto L68;
   goto L70;
L72:;
   goto L70;
L70:;
   if (!((v2output_file)==(ECL_NIL))) { goto L75; }
   goto L68;
   goto L69;
L75:;
   goto L69;
L69:;
   value0 = v2output_file;
   cl_env_copy->nvalues = 1;
   return value0;
L68:;
   if (Null(v6format)) { goto L77; }
   T0 = cl_pathname_name(1, v1name);
   T1 = cl_format(3, ECL_NIL, v6format, T0);
   value0 = cl_merge_pathnames(2, T1, v1name);
   return value0;
L77:;
   value0 = cl_make_pathname(4, ECL_SYM("TYPE",1353), v7extension, ECL_SYM("DEFAULTS",1244), v1name);
   return value0;
  }
 }
}
/*      function definition for COMPILE-FILE                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4027compile_file(volatile cl_narg narg, cl_object volatile v1input_pathname, ...)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v2args;
  cl_object volatile v3c_file;
  cl_object volatile v4h_file;
  cl_object volatile v5data_file;
  cl_object volatile v6system_p;
  cl_object volatile v7output_file;
  ecl_va_list args; ecl_va_start(args,v1input_pathname,narg,1);
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v1input_pathname,env0);      /*  INPUT-PATHNAME  */
  {
   cl_object keyvars[22];
   cl_parse_key(args,11,L4027compile_filekeys,keyvars,(cl_object*)&v2args,FALSE);
   CLV1 = env0 = CONS(v2args,env0);               /*  ARGS            */
   ecl_va_end(args);
   if (Null(keyvars[11])) {
    ecl_bds_push(cl_env_copy,ECL_SYM("*COMPILE-VERBOSE*",31)); /*  *COMPILE-VERBOSE* */
   } else {
    ecl_bds_bind(cl_env_copy,ECL_SYM("*COMPILE-VERBOSE*",31),keyvars[0]); /*  *COMPILE-VERBOSE* */
   }
   if (Null(keyvars[12])) {
    ecl_bds_push(cl_env_copy,ECL_SYM("*COMPILE-PRINT*",30)); /*  *COMPILE-PRINT* */
   } else {
    ecl_bds_bind(cl_env_copy,ECL_SYM("*COMPILE-PRINT*",30),keyvars[1]); /*  *COMPILE-PRINT* */
   }
   CLV2 = env0 = CONS(keyvars[2],env0);           /*  SOURCE-TRUENAME */
   if (Null(keyvars[14])) {
    CLV3 = env0 = CONS(ecl_make_fixnum(0),env0);  /*  SOURCE-OFFSET   */
   } else {
    CLV3 = env0 = CONS(keyvars[3],env0);          /*  SOURCE-OFFSET   */
   }
   v3c_file = keyvars[4];
   v4h_file = keyvars[5];
   v5data_file = keyvars[6];
   v6system_p = keyvars[7];
   CLV4 = env0 = CONS(keyvars[8],env0);           /*  LOAD            */
   if (Null(keyvars[20])) {
    CLV5 = env0 = CONS(ECL_SYM("DEFAULT",1243),env0); /*  EXTERNAL-FORMAT */
   } else {
    CLV5 = env0 = CONS(keyvars[9],env0);          /*  EXTERNAL-FORMAT */
   }
   v7output_file = keyvars[10];
  }
  ecl_bds_push(cl_env_copy,ECL_SYM("*STANDARD-OUTPUT*",69)); /*  *STANDARD-OUTPUT* */
  ecl_bds_push(cl_env_copy,ECL_SYM("*ERROR-OUTPUT*",35)); /*  *ERROR-OUTPUT* */
  ecl_bds_push(cl_env_copy,VV[35]);               /*  *COMPILER-IN-USE* */
  ecl_bds_push(cl_env_copy,ECL_SYM("*PACKAGE*",45)); /*  *PACKAGE*    */
  ecl_bds_push(cl_env_copy,ECL_SYM("*READTABLE*",67)); /*  *READTABLE* */
  ecl_bds_bind(cl_env_copy,ECL_SYM("*PRINT-PRETTY*",57),ECL_NIL); /*  *PRINT-PRETTY* */
  ecl_bds_bind(cl_env_copy,ECL_SYM("*COMPILE-FILE-PATHNAME*",28),ECL_NIL); /*  *COMPILE-FILE-PATHNAME* */
  ecl_bds_bind(cl_env_copy,ECL_SYM("*COMPILE-FILE-TRUENAME*",29),ECL_NIL); /*  *COMPILE-FILE-TRUENAME* */
  T0 = CONS(ECL_CONS_CAR(CLV2),ecl_make_fixnum(0));
  ecl_bds_bind(cl_env_copy,ECL_SYM("*SOURCE-LOCATION*",1207),T0); /*  *SOURCE-LOCATION* */
  value0 = ecl_symbol_value(VV[36]);
  if ((value0)!=ECL_NIL) { goto L3; }
  T0 = Null(ecl_symbol_value(ECL_SYM("*COMPILE-VERBOSE*",31)))?ECL_T:ECL_NIL;
  goto L1;
L3:;
  T0 = value0;
  goto L1;
L1:;
  ecl_bds_bind(cl_env_copy,VV[36],T0);            /*  *SUPPRESS-COMPILER-MESSAGES* */
  T0 = cl_merge_pathnames(1, ECL_CONS_CAR(CLV0));
  cl_set(ECL_SYM("*COMPILE-FILE-PATHNAME*",28),cl_pathname(T0));
  if ((cl_probe_file(ecl_symbol_value(ECL_SYM("*COMPILE-FILE-PATHNAME*",28))))!=ECL_NIL) { goto L7; }
  if (Null(cl_pathname_type(1, ECL_CONS_CAR(CLV0)))) { goto L9; }
  cl_error(3, ECL_SYM("FILE-ERROR",355), ECL_SYM("PATHNAME",1319), ECL_CONS_CAR(CLV0));
  goto L7;
L9:;
  {
   cl_object v8;
   v8 = VV[37];
   goto L14;
L13:;
   {
    cl_object v9ext;
    v9ext = ecl_car(v8);
    cl_set(ECL_SYM("*COMPILE-FILE-PATHNAME*",28),cl_make_pathname(4, ECL_SYM("TYPE",1353), v9ext, ECL_SYM("DEFAULTS",1244), ECL_CONS_CAR(CLV0)));
    if (Null(cl_probe_file(ecl_symbol_value(ECL_SYM("*COMPILE-FILE-PATHNAME*",28))))) { goto L20; }
    goto L7;
L20:;
   }
   v8 = ecl_cdr(v8);
L14:;
   if (Null(v8)) { goto L24; }
   goto L13;
L24:;
   cl_error(3, ECL_SYM("FILE-ERROR",355), ECL_SYM("PATHNAME",1319), ECL_CONS_CAR(CLV0));
  }
L7:;
  if (Null(v6system_p)) { goto L26; }
  if (Null(ECL_CONS_CAR(CLV4))) { goto L26; }
  cl_error(1, VV[38]);
L26:;
  T0 = cl_namestring(ECL_CONS_CAR(CLV0));
  ecl_function_dispatch(cl_env_copy,VV[138])(2, VV[39], T0) /*  CMPPROGRESS */;
  {
   volatile cl_object v8compiler_conditions;
   volatile cl_object env1 = env0;
   T0 = cl_truename(ecl_symbol_value(ECL_SYM("*COMPILE-FILE-PATHNAME*",28)));
   CLV6 = env1 = CONS(T0,env1);                   /*  INPUT-FILE      */
   ecl_bds_bind(cl_env_copy,ECL_SYM("*COMPILE-FILE-TRUENAME*",29),ECL_CONS_CAR(CLV6)); /*  *COMPILE-FILE-TRUENAME* */
   ecl_bds_push(cl_env_copy,VV[35]);              /*  *COMPILER-IN-USE* */
   ecl_bds_bind(cl_env_copy,VV[40],ECL_NIL);      /*  *LOAD-TIME-VALUES* */
   T0 = (VV[34]->symbol.gfdef);
   T1 = cl_apply(5, T0, ECL_CONS_CAR(CLV6), VV[41], v7output_file, ECL_CONS_CAR(CLV1));
   CLV7 = env1 = CONS(T1,env1);                   /*  OUTPUT-FILE     */
   CLV8 = env1 = CONS(ECL_NIL,env1);              /*  TRUE-OUTPUT-FILE */
   v8compiler_conditions = ECL_NIL;
   ecl_bds_bind(cl_env_copy,VV[42],ECL_NIL);      /*  *COMPILER-CONDITIONS* */
   {
    volatile cl_object env2 = env1;
    CLV9 = env2 = CONS(ECL_NIL,env2);
    {
     volatile cl_object env3 = env2;
     CLV10 = env3 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env3); /*  TAGBODY */
     {
      ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV10));
      if (__ecl_frs_push_result) {
      if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L34;
      ecl_internal_error("GO found an inexistent tag");
      }
     }
     {
      cl_object volatile v9;
      v9 = ecl_make_cclosure_va((cl_objectfn)LC4025__lambda70,env3,Cblock,0);
      T0 = v9;
     }
     T1 = ecl_function_dispatch(cl_env_copy,VV[139])(4, ECL_SYM("NAME",1306), ECL_SYM("ABORT",79), ECL_SYM("FUNCTION",1270), T0) /*  MAKE-RESTART */;
     T2 = ecl_list1(T1);
     T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*RESTART-CLUSTERS*",5)));
     ecl_bds_bind(cl_env_copy,ECL_SYM("*RESTART-CLUSTERS*",5),T3); /*  *RESTART-CLUSTERS* */
     T0 = ecl_fdefinition(VV[140]);
     T1 = CONS(VV[43],T0);
     T2 = ecl_fdefinition(VV[141]);
     T3 = CONS(ECL_SYM("WARNING",906),T2);
     T4 = ecl_fdefinition(VV[142]);
     T5 = CONS(VV[44],T4);
     T6 = ecl_fdefinition(VV[143]);
     T7 = CONS(VV[45],T6);
     T8 = ecl_fdefinition(VV[143]);
     T9 = CONS(ECL_SYM("SERIOUS-CONDITION",744),T8);
     T10 = cl_list(5, T1, T3, T5, T7, T9);
     T11 = CONS(T10,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
     ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T11); /*  *HANDLER-CLUSTERS* */
     {
      volatile cl_object v9;
      v9 = ecl_symbol_value(ECL_SYM("+LOAD-COMPILE-LOCK+",1469));
      if (Null(mp_get_lock(2, v9, ECL_T))) {
      ecl_frs_pop(cl_env_copy);
      ecl_bds_unwind1(cl_env_copy);
      ecl_bds_unwind1(cl_env_copy);
       goto L33;
      }
      {
       struct ecl_stack_frame _ecl_inner_frame_aux;
       volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
       {
        volatile cl_object v10;
        v10 = _ecl_inner_frame;
        {
         volatile cl_object v11;
         v11 = ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7));
         ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),ECL_NIL); /*  *INTERRUPTS-ENABLED* */
         ecl_bds_bind(cl_env_copy,ECL_SYM("*ALLOW-WITH-INTERRUPTS*",1814),ECL_NIL); /*  *ALLOW-WITH-INTERRUPTS* */
         {
          volatile bool unwinding = FALSE;
          cl_index v12=ECL_STACK_INDEX(cl_env_copy),v13;
          ecl_frame_ptr next_fr;
          ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
          if (__ecl_frs_push_result) {
            unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
          } else {
          ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),v11); /*  *INTERRUPTS-ENABLED* */
          {
          volatile cl_object v14;
          volatile cl_object v15;
          volatile cl_object v16;
          volatile cl_object v17;
          volatile cl_object v18;
          v14 = cl_copy_tree(ecl_symbol_value(VV[47]));
          T0 = (ECL_SYM("EQUAL",337)->symbol.gfdef);
          v15 = cl_make_hash_table(4, ECL_SYM("SIZE",1342), ecl_make_fixnum(128), ECL_SYM("TEST",1350), T0);
          value0 = ecl_symbol_value(VV[49]);
          if ((value0)!=ECL_NIL) { goto L55; }
          v16 = ecl_symbol_value(VV[50]);
          goto L53;
L55:;
          v16 = value0;
          goto L53;
L53:;
          v17 = ecl_function_dispatch(cl_env_copy,VV[144])(1, ecl_symbol_value(VV[49])) /*  MAKE-OPTIMIZABLE-CONSTANTS */;
          {
          cl_object v19r;
          v19r = ecl_function_dispatch(cl_env_copy,VV[145])(1, ecl_symbol_value(VV[49])) /*  MACHINE-INLINE-INFORMATION */;
          if (Null(v19r)) { goto L60; }
          v18 = si_copy_hash_table(v19r);
          goto L58;
L60:;
          v18 = ecl_function_dispatch(cl_env_copy,VV[146])(1, ecl_symbol_value(VV[49])) /*  MAKE-INLINE-INFORMATION */;
          }
L58:;
          ecl_bds_bind(cl_env_copy,ECL_SYM("*GENSYM-COUNTER*",37),ecl_make_fixnum(0)); /*  *GENSYM-COUNTER* */
          ecl_bds_bind(cl_env_copy,VV[35],ECL_T); /*  *COMPILER-IN-USE* */
          ecl_bds_bind(cl_env_copy,VV[51],VV[46]); /*  *COMPILER-PHASE* */
          ecl_bds_bind(cl_env_copy,VV[52],ECL_NIL); /*  *CALLBACKS*   */
          ecl_bds_bind(cl_env_copy,VV[47],v14);   /*  *CMP-ENV-ROOT*  */
          ecl_bds_bind(cl_env_copy,VV[53],ECL_NIL); /*  *CMP-ENV*     */
          ecl_bds_bind(cl_env_copy,VV[54],v15);   /*  *LOAD-OBJECTS*  */
          ecl_bds_bind(cl_env_copy,VV[55],ECL_NIL); /*  *SETF-DEFINITIONS* */
          ecl_bds_bind(cl_env_copy,VV[56],ECL_NIL); /*  *MAKE-FORMS*  */
          ecl_bds_bind(cl_env_copy,VV[57],ECL_NIL); /*  *STATIC-CONSTANTS* */
          ecl_bds_bind(cl_env_copy,VV[58],ECL_NIL); /*  *PERMANENT-OBJECTS* */
          ecl_bds_bind(cl_env_copy,VV[59],ECL_NIL); /*  *TEMPORARY-OBJECTS* */
          ecl_bds_bind(cl_env_copy,VV[60],ECL_NIL); /*  *LOCAL-FUNS*  */
          ecl_bds_bind(cl_env_copy,VV[61],ECL_NIL); /*  *GLOBAL-VARS* */
          ecl_bds_bind(cl_env_copy,VV[62],ECL_NIL); /*  *GLOBAL-FUNS* */
          ecl_bds_bind(cl_env_copy,VV[63],ECL_NIL); /*  *GLOBAL-CFUNS-ARRAY* */
          ecl_bds_bind(cl_env_copy,VV[64],ECL_NIL); /*  *UNDEFINED-VARS* */
          ecl_bds_bind(cl_env_copy,VV[65],ECL_NIL); /*  *TOP-LEVEL-FORMS* */
          ecl_bds_bind(cl_env_copy,VV[66],ECL_NIL); /*  *COMPILE-TIME-TOO* */
          ecl_bds_bind(cl_env_copy,VV[67],ECL_NIL); /*  *CLINES-STRING-LIST* */
          ecl_bds_bind(cl_env_copy,VV[68],VV[48]); /*  *DEFUN-INLINE-HOOK* */
          ecl_bds_bind(cl_env_copy,VV[49],v16);   /*  *MACHINE*       */
          ecl_bds_bind(cl_env_copy,VV[69],v17);   /*  *OPTIMIZABLE-CONSTANTS* */
          ecl_bds_bind(cl_env_copy,VV[70],v18);   /*  *INLINE-INFORMATION* */
          {
          cl_object volatile v19;
          v19 = ecl_make_cclosure_va((cl_objectfn)LC4026__lambda111,env3,Cblock,0);
          T0 = v19;
          }
          cl_env_copy->values[0] = ecl_function_dispatch(cl_env_copy,VV[147])(1, T0) /*  DO-COMPILATION-UNIT */;
          ecl_bds_unwind_n(cl_env_copy,25);
          }
            next_fr = NULL;
          }
          ecl_frs_pop(cl_env_copy);
          v13=ecl_stack_push_values(cl_env_copy);
          mp_giveup_lock(v9);
          ecl_stack_pop_values(cl_env_copy,v13);
          if (unwinding) ecl_unwind(cl_env_copy,next_fr);
          ECL_STACK_SET_INDEX(cl_env_copy,v12);
          ecl_bds_unwind1(cl_env_copy);
          ecl_bds_unwind1(cl_env_copy);
         }
        }
        ecl_stack_frame_push_values(v10);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        if (Null(ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7)))) { goto L64; }
        si_check_pending_interrupts();
L64:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v10);
       }
       ecl_stack_frame_close(_ecl_inner_frame);
      }
      ecl_frs_pop(cl_env_copy);
      ecl_bds_unwind1(cl_env_copy);
      ecl_bds_unwind1(cl_env_copy);
      goto L33;
     }
L34:;
     {
      cl_object v9;
      v9 = ECL_CONS_CAR(CLV9);
      if (Null(v9)) {
      ecl_frs_pop(cl_env_copy); goto L33; }
      ecl_function_dispatch(cl_env_copy,VV[148])(1, ECL_NIL) /*  DM-TOO-MANY-ARGUMENTS */;
      ecl_frs_pop(cl_env_copy);
      goto L33;
     }
    }
   }
L33:;
   v8compiler_conditions = ecl_symbol_value(VV[42]);
   ecl_bds_unwind1(cl_env_copy);
   T0 = ECL_CONS_CAR(CLV8);
   value0 = L4028compiler_output_values(T0, v8compiler_conditions);
   ecl_bds_unwind_n(cl_env_copy,15);
   return value0;
  }
 }
}
/*      closure LAMBDA70                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4025__lambda70(cl_narg narg, ...)
{
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV10 = env0;                                    /*  TAGBODY         */
 CLV9 = _ecl_cdr(CLV10);
 CLV8 = _ecl_cdr(CLV9);
 CLV7 = _ecl_cdr(CLV8);
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 {
  cl_object v1si__temp;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1si__temp = cl_grab_rest_args(args);
  ecl_va_end(args);
  ECL_CONS_CAR(CLV9) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV10),ecl_make_fixnum(0));
 }
 }
}
/*      closure LAMBDA111                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4026__lambda111(volatile cl_narg narg, ...)
{
 cl_object T0;
 cl_object volatile CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile env0 = cl_env_copy->function->cclosure.env;
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV10 = env0;
 CLV9 = _ecl_cdr(CLV10);
 CLV8 = _ecl_cdr(CLV9);                           /*  TRUE-OUTPUT-FILE */
 CLV7 = _ecl_cdr(CLV8);
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=0)) FEwrong_num_arguments_anonym();
 {
TTL:
  L4039print_compiler_info();
  if (Null(cl_probe_file(VV[71]))) { goto L2; }
  cl_load(3, VV[71], ECL_SYM("VERBOSE",1360), ecl_symbol_value(ECL_SYM("*COMPILE-VERBOSE*",31)));
L2:;
  {
   volatile cl_object v1stream;
   v1stream = cl_open(3, ecl_symbol_value(ECL_SYM("*COMPILE-FILE-PATHNAME*",28)), ECL_SYM("EXTERNAL-FORMAT",1264), ECL_CONS_CAR(CLV5));
   {
    volatile bool unwinding = FALSE;
    cl_index v2=ECL_STACK_INDEX(cl_env_copy),v3;
    ecl_frame_ptr next_fr;
    ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
    if (__ecl_frs_push_result) {
      unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
    } else {
    {
     struct ecl_stack_frame _ecl_inner_frame_aux;
     volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
     {
      cl_object v4;
      v4 = _ecl_inner_frame;
      if ((ECL_CONS_CAR(CLV2))!=ECL_NIL) { goto L11; }
      {
       cl_object v5;
       v5 = ecl_symbol_value(ECL_SYM("*SOURCE-LOCATION*",1207));
       {
        cl_object v6;
        v6 = ecl_symbol_value(ECL_SYM("*COMPILE-FILE-PATHNAME*",28));
        {
         cl_object v7;
         v7 = v5;
         if (ecl_unlikely(ECL_ATOM(v7))) FEtype_error_cons(v7);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         T0 = v7;
        }
        (ECL_CONS_CAR(T0)=v6,T0);
       }
      }
L11:;
      cl_env_copy->values[0] = L4037compiler_pass1(2, v1stream, ECL_CONS_CAR(CLV3));
      ecl_stack_frame_push_values(v4);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      if (Null(v1stream)) { goto L19; }
      cl_close(1, v1stream);
L19:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v4);
     }
     ecl_stack_frame_close(_ecl_inner_frame);
    }
      next_fr = NULL;
    }
    ecl_frs_pop(cl_env_copy);
    v3=ecl_stack_push_values(cl_env_copy);
    if (Null(v1stream)) { goto L21; }
    cl_close(3, v1stream, ECL_SYM("ABORT",1222), ECL_T);
L21:;
    ecl_stack_pop_values(cl_env_copy,v3);
    if (unwinding) ecl_unwind(cl_env_copy,next_fr);
    ECL_STACK_SET_INDEX(cl_env_copy,v2);
   }
  }
  L4038compiler_pass_propagate_types();
  T0 = ecl_fdefinition(VV[149]);
  cl_apply(4, T0, ECL_CONS_CAR(CLV6), ECL_CONS_CAR(CLV7), ECL_CONS_CAR(CLV1));
  ECL_CONS_CAR(CLV8) = cl_probe_file(ECL_CONS_CAR(CLV7));
  if (Null(ECL_CONS_CAR(CLV8))) { goto L27; }
  T0 = cl_namestring(ECL_CONS_CAR(CLV0));
  ecl_function_dispatch(cl_env_copy,VV[138])(2, VV[72], T0) /*  CMPPROGRESS */;
  goto L26;
L27:;
  ecl_function_dispatch(cl_env_copy,VV[150])(1, VV[73]) /*  CMPERR    */;
L26:;
  if (Null(ECL_CONS_CAR(CLV4))) { goto L30; }
  T0 = ECL_CONS_CAR(CLV8);
  value0 = cl_load(3, T0, ECL_SYM("VERBOSE",1360), ecl_symbol_value(ECL_SYM("*COMPILE-VERBOSE*",31)));
  return value0;
L30:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
 }
}
/*      function definition for COMPILER-OUTPUT-VALUES                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4028compiler_output_values(cl_object v1main_value, cl_object v2conditions)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3i;
   cl_object v4;
   v3i = ECL_NIL;
   {
    cl_object v5;
    v5 = v2conditions;
    if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v4 = v5;
   }
   {
    cl_object v5warning_p;
    v5warning_p = ECL_NIL;
    {
     cl_object v6failure_p;
     v6failure_p = ECL_NIL;
L7:;
     if (!(ecl_endp(v4))) { goto L9; }
     goto L8;
L9:;
     v3i = ECL_CONS_CAR(v4);
     {
      cl_object v7;
      v7 = ECL_CONS_CDR(v4);
      if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v4 = v7;
     }
     if (Null(si_of_class_p(2, v3i, ECL_SYM("STYLE-WARNING",829)))) { goto L18; }
     v5warning_p = ECL_T;
     goto L17;
L18:;
     if ((si_of_class_p(2, v3i, VV[44]))!=ECL_NIL) { goto L22; }
     if (Null(si_of_class_p(2, v3i, ECL_SYM("WARNING",906)))) { goto L17; }
     goto L21;
L22:;
L21:;
     v5warning_p = ECL_T;
     v6failure_p = ECL_T;
L17:;
     goto L7;
L8:;
     cl_env_copy->nvalues = 3;
     cl_env_copy->values[2] = v6failure_p;
     cl_env_copy->values[1] = v5warning_p;
     cl_env_copy->values[0] = v1main_value;
     return cl_env_copy->values[0];
    }
   }
  }
 }
}
/*      function definition for COMPILE                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4032compile(volatile cl_narg narg, cl_object volatile v1name, ...)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v2def;
  cl_object volatile v3supplied_p;
  va_list args; va_start(args,v1name);
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v1name,env0);                /*  NAME            */
  {
   int i = 1;
   if (i >= narg) {
    v2def = ECL_NIL;
    v3supplied_p = ECL_NIL;
   } else {
    i++;
    v2def = va_arg(args,cl_object);
    v3supplied_p = ECL_T;
   }
  }
  va_end(args);
  {
   volatile cl_object env1 = env0;
   CLV1 = env1 = CONS(ECL_NIL,env1);              /*  FORM            */
   CLV2 = env1 = CONS(ECL_NIL,env1);              /*  LEXENV          */
   value0 = ecl_symbol_value(VV[36]);
   if ((value0)!=ECL_NIL) { goto L4; }
   T0 = Null(ecl_symbol_value(ECL_SYM("*COMPILE-VERBOSE*",31)))?ECL_T:ECL_NIL;
   goto L2;
L4:;
   T0 = value0;
   goto L2;
L2:;
   ecl_bds_bind(cl_env_copy,VV[36],T0);           /*  *SUPPRESS-COMPILER-MESSAGES* */
   ecl_bds_push(cl_env_copy,VV[35]);              /*  *COMPILER-IN-USE* */
   ecl_bds_push(cl_env_copy,ECL_SYM("*STANDARD-OUTPUT*",69)); /*  *STANDARD-OUTPUT* */
   ecl_bds_push(cl_env_copy,ECL_SYM("*ERROR-OUTPUT*",35)); /*  *ERROR-OUTPUT* */
   ecl_bds_push(cl_env_copy,ECL_SYM("*PACKAGE*",45)); /*  *PACKAGE*   */
   ecl_bds_bind(cl_env_copy,ECL_SYM("*COMPILE-PRINT*",30),ECL_NIL); /*  *COMPILE-PRINT* */
   ecl_bds_bind(cl_env_copy,ECL_SYM("*PRINT-PRETTY*",57),ECL_NIL); /*  *PRINT-PRETTY* */
   ecl_bds_bind(cl_env_copy,ECL_SYM("*COMPILER-CONSTANTS*",1019),ECL_T); /*  *COMPILER-CONSTANTS* */
   if ((si_valid_function_name_p(ECL_CONS_CAR(CLV0)))!=ECL_NIL) { goto L6; }
   cl_error(2, VV[77], ECL_CONS_CAR(CLV0));
L6:;
   if (Null(v3supplied_p)) { goto L9; }
   if (Null(v2def)) { goto L9; }
   if (Null(cl_functionp(v2def))) { goto L12; }
   if ((cl_function_lambda_expression(v2def))!=ECL_NIL) { goto L14; }
   value0 = v2def;
   cl_env_copy->nvalues = 1;
   ecl_bds_unwind_n(cl_env_copy,8);
   return value0;
L14:;
   {
    cl_object v4;
    v4 = ECL_NIL;
    value0 = cl_function_lambda_expression(v2def);
    {
     v4 = value0;
     ECL_CONS_CAR(CLV2) = cl_env_copy->values[1];
    }
    {
     cl_object v5;
     v5 = v4;
     value0 = ecl_make_bool(ECL_LISTP(v5));
     if ((value0)!=ECL_NIL) { goto L26; }
     T0 = cl_functionp(v5);
     goto L24;
L26:;
     T0 = value0;
     goto L24;
L24:;
     if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[78],v5);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v2def = v5;
    }
   }
   if (!((ECL_CONS_CAR(CLV2))==(ECL_T))) { goto L12; }
   (cl_env_copy->function=(ECL_SYM("WARN",905)->symbol.gfdef))->cfun.entry(1, VV[79]) /*  WARN */;
   cl_env_copy->nvalues = 3;
   cl_env_copy->values[2] = ECL_NIL;
   cl_env_copy->values[1] = ECL_T;
   cl_env_copy->values[0] = v2def;
   ecl_bds_unwind_n(cl_env_copy,8);
   return cl_env_copy->values[0];
L12:;
   if (Null(ECL_CONS_CAR(CLV0))) { goto L31; }
   T0 = cl_list(2, ECL_SYM("QUOTE",681), ECL_CONS_CAR(CLV0));
   T1 = cl_list(2, ECL_SYM("FDEFINITION",351), T0);
   T2 = cl_list(2, ECL_SYM("FUNCTION",398), v2def);
   ECL_CONS_CAR(CLV1) = cl_list(3, ECL_SYM("SETF",752), T1, T2);
   goto L30;
L31:;
   T0 = cl_list(2, ECL_SYM("FUNCTION",398), v2def);
   ECL_CONS_CAR(CLV1) = cl_list(3, ECL_SYM("SET",745), VV[80], T0);
L30:;
   goto L8;
L9:;
   if ((cl_fboundp(ECL_CONS_CAR(CLV0)))!=ECL_NIL) { goto L33; }
   cl_error(2, VV[81], ECL_CONS_CAR(CLV0));
   goto L8;
L33:;
   v2def = cl_fdefinition(ECL_CONS_CAR(CLV0));
   if (Null(si_of_class_p(2, v2def, ECL_SYM("STANDARD-GENERIC-FUNCTION",976)))) { goto L35; }
   (cl_env_copy->function=(ECL_SYM("WARN",905)->symbol.gfdef))->cfun.entry(1, VV[82]) /*  WARN */;
   cl_env_copy->nvalues = 3;
   cl_env_copy->values[2] = ECL_NIL;
   cl_env_copy->values[1] = ECL_T;
   cl_env_copy->values[0] = v2def;
   ecl_bds_unwind_n(cl_env_copy,8);
   return cl_env_copy->values[0];
L35:;
   ECL_CONS_CAR(CLV1) = cl_function_lambda_expression(v2def);
   if (!(ECL_CONS_CAR(CLV1)==ECL_NIL)) { goto L39; }
   (cl_env_copy->function=(ECL_SYM("WARN",905)->symbol.gfdef))->cfun.entry(2, VV[83], ECL_CONS_CAR(CLV0)) /*  WARN */;
   cl_env_copy->nvalues = 3;
   cl_env_copy->values[2] = ECL_NIL;
   cl_env_copy->values[1] = ECL_T;
   cl_env_copy->values[0] = v2def;
   ecl_bds_unwind_n(cl_env_copy,8);
   return cl_env_copy->values[0];
L39:;
   T0 = cl_list(2, ECL_SYM("QUOTE",681), ECL_CONS_CAR(CLV0));
   T1 = cl_list(2, ECL_SYM("FDEFINITION",351), T0);
   T2 = cl_list(2, ECL_SYM("FUNCTION",398), ECL_CONS_CAR(CLV1));
   ECL_CONS_CAR(CLV1) = cl_list(3, ECL_SYM("SETF",752), T1, T2);
L8:;
   {
    volatile cl_object env2 = env1;
    ecl_bds_bind(cl_env_copy,VV[40],ECL_SYM("VALUES",897)); /*  *LOAD-TIME-VALUES* */
    cl_set(VV[76],ecl_plus(ecl_symbol_value(VV[76]),ecl_make_fixnum(1)));
    T0 = ecl_symbol_value(VV[76]);
    T1 = cl_format(3, ECL_NIL, VV[84], T0);
    T2 = ecl_function_dispatch(cl_env_copy,VV[153])(1, T1) /*  SAFE-MKSTEMP */;
    CLV3 = env2 = CONS(T2,env2);                  /*  TMP-NAMES       */
    T0 = ecl_car(ECL_CONS_CAR(CLV3));
    T1 = L4024compile_file_pathname(1, T0);
    CLV4 = env2 = CONS(T1,env2);                  /*  SO-PATHNAME     */
    CLV5 = env2 = CONS(ECL_NIL,env2);             /*  COMPILER-CONDITIONS */
    ecl_bds_bind(cl_env_copy,VV[85],ECL_T);       /*  *PERMANENT-DATA* */
    ecl_bds_push(cl_env_copy,VV[47]);             /*  *CMP-ENV-ROOT*  */
    ecl_bds_bind(cl_env_copy,VV[42],ECL_NIL);     /*  *COMPILER-CONDITIONS* */
    {
     volatile cl_object env3 = env2;
     CLV6 = env3 = CONS(ECL_NIL,env3);
     {
      volatile cl_object env4 = env3;
      CLV7 = env4 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env4); /*  TAGBODY */
      {
       ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV7));
       if (__ecl_frs_push_result) {
       if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L48;
       ecl_internal_error("GO found an inexistent tag");
       }
      }
      {
       cl_object volatile v4;
       v4 = ecl_make_cclosure_va((cl_objectfn)LC4029__lambda135,env4,Cblock,0);
       T0 = v4;
      }
      T1 = ecl_function_dispatch(cl_env_copy,VV[139])(4, ECL_SYM("NAME",1306), ECL_SYM("ABORT",79), ECL_SYM("FUNCTION",1270), T0) /*  MAKE-RESTART */;
      T2 = ecl_list1(T1);
      T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*RESTART-CLUSTERS*",5)));
      ecl_bds_bind(cl_env_copy,ECL_SYM("*RESTART-CLUSTERS*",5),T3); /*  *RESTART-CLUSTERS* */
      T0 = ecl_fdefinition(VV[140]);
      T1 = CONS(VV[43],T0);
      T2 = ecl_fdefinition(VV[141]);
      T3 = CONS(ECL_SYM("WARNING",906),T2);
      T4 = ecl_fdefinition(VV[142]);
      T5 = CONS(VV[44],T4);
      T6 = ecl_fdefinition(VV[143]);
      T7 = CONS(VV[45],T6);
      T8 = ecl_fdefinition(VV[143]);
      T9 = CONS(ECL_SYM("SERIOUS-CONDITION",744),T8);
      T10 = cl_list(5, T1, T3, T5, T7, T9);
      T11 = CONS(T10,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
      ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T11); /*  *HANDLER-CLUSTERS* */
      {
       volatile cl_object v4;
       v4 = ecl_symbol_value(ECL_SYM("+LOAD-COMPILE-LOCK+",1469));
       if (Null(mp_get_lock(2, v4, ECL_T))) {
       ecl_frs_pop(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
        goto L47;
       }
       {
        struct ecl_stack_frame _ecl_inner_frame_aux;
        volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
        {
         volatile cl_object v5;
         v5 = _ecl_inner_frame;
         {
          volatile cl_object v6;
          v6 = ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7));
          ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),ECL_NIL); /*  *INTERRUPTS-ENABLED* */
          ecl_bds_bind(cl_env_copy,ECL_SYM("*ALLOW-WITH-INTERRUPTS*",1814),ECL_NIL); /*  *ALLOW-WITH-INTERRUPTS* */
          {
          volatile bool unwinding = FALSE;
          cl_index v7=ECL_STACK_INDEX(cl_env_copy),v8;
          ecl_frame_ptr next_fr;
          ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
          if (__ecl_frs_push_result) {
            unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
          } else {
          ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),v6); /*  *INTERRUPTS-ENABLED* */
          {
          cl_object v9;
          cl_object v10;
          cl_object v11;
          cl_object v12;
          cl_object v13;
          v9 = cl_copy_tree(ecl_symbol_value(VV[47]));
          T0 = (ECL_SYM("EQUAL",337)->symbol.gfdef);
          v10 = cl_make_hash_table(4, ECL_SYM("SIZE",1342), ecl_make_fixnum(128), ECL_SYM("TEST",1350), T0);
          value0 = ecl_symbol_value(VV[49]);
          if ((value0)!=ECL_NIL) { goto L69; }
          v11 = ecl_symbol_value(VV[50]);
          goto L67;
L69:;
          v11 = value0;
          goto L67;
L67:;
          v12 = ecl_function_dispatch(cl_env_copy,VV[144])(1, ecl_symbol_value(VV[49])) /*  MAKE-OPTIMIZABLE-CONSTANTS */;
          {
          cl_object v14r;
          v14r = ecl_function_dispatch(cl_env_copy,VV[145])(1, ecl_symbol_value(VV[49])) /*  MACHINE-INLINE-INFORMATION */;
          if (Null(v14r)) { goto L74; }
          v13 = si_copy_hash_table(v14r);
          goto L72;
L74:;
          v13 = ecl_function_dispatch(cl_env_copy,VV[146])(1, ecl_symbol_value(VV[49])) /*  MAKE-INLINE-INFORMATION */;
          }
L72:;
          ecl_bds_bind(cl_env_copy,ECL_SYM("*GENSYM-COUNTER*",37),ecl_make_fixnum(0)); /*  *GENSYM-COUNTER* */
          ecl_bds_bind(cl_env_copy,VV[35],ECL_T); /*  *COMPILER-IN-USE* */
          ecl_bds_bind(cl_env_copy,VV[51],VV[46]); /*  *COMPILER-PHASE* */
          ecl_bds_bind(cl_env_copy,VV[52],ECL_NIL); /*  *CALLBACKS*   */
          ecl_bds_bind(cl_env_copy,VV[47],v9);    /*  *CMP-ENV-ROOT*  */
          ecl_bds_bind(cl_env_copy,VV[53],ECL_NIL); /*  *CMP-ENV*     */
          ecl_bds_bind(cl_env_copy,VV[54],v10);   /*  *LOAD-OBJECTS*  */
          ecl_bds_bind(cl_env_copy,VV[55],ECL_NIL); /*  *SETF-DEFINITIONS* */
          ecl_bds_bind(cl_env_copy,VV[56],ECL_NIL); /*  *MAKE-FORMS*  */
          ecl_bds_bind(cl_env_copy,VV[57],ECL_NIL); /*  *STATIC-CONSTANTS* */
          ecl_bds_bind(cl_env_copy,VV[58],ECL_NIL); /*  *PERMANENT-OBJECTS* */
          ecl_bds_bind(cl_env_copy,VV[59],ECL_NIL); /*  *TEMPORARY-OBJECTS* */
          ecl_bds_bind(cl_env_copy,VV[60],ECL_NIL); /*  *LOCAL-FUNS*  */
          ecl_bds_bind(cl_env_copy,VV[61],ECL_NIL); /*  *GLOBAL-VARS* */
          ecl_bds_bind(cl_env_copy,VV[62],ECL_NIL); /*  *GLOBAL-FUNS* */
          ecl_bds_bind(cl_env_copy,VV[63],ECL_NIL); /*  *GLOBAL-CFUNS-ARRAY* */
          ecl_bds_bind(cl_env_copy,VV[64],ECL_NIL); /*  *UNDEFINED-VARS* */
          ecl_bds_bind(cl_env_copy,VV[65],ECL_NIL); /*  *TOP-LEVEL-FORMS* */
          ecl_bds_bind(cl_env_copy,VV[66],ECL_NIL); /*  *COMPILE-TIME-TOO* */
          ecl_bds_bind(cl_env_copy,VV[67],ECL_NIL); /*  *CLINES-STRING-LIST* */
          ecl_bds_bind(cl_env_copy,VV[68],VV[48]); /*  *DEFUN-INLINE-HOOK* */
          ecl_bds_bind(cl_env_copy,VV[49],v11);   /*  *MACHINE*       */
          ecl_bds_bind(cl_env_copy,VV[69],v12);   /*  *OPTIMIZABLE-CONSTANTS* */
          ecl_bds_bind(cl_env_copy,VV[70],v13);   /*  *INLINE-INFORMATION* */
          {
          cl_object v14;
          v14 = ecl_make_cclosure_va((cl_objectfn)LC4030__lambda176,env4,Cblock,0);
          T0 = v14;
          }
          cl_env_copy->values[0] = ecl_function_dispatch(cl_env_copy,VV[147])(1, T0) /*  DO-COMPILATION-UNIT */;
          ecl_bds_unwind_n(cl_env_copy,25);
          }
            next_fr = NULL;
          }
          ecl_frs_pop(cl_env_copy);
          v8=ecl_stack_push_values(cl_env_copy);
          mp_giveup_lock(v4);
          ecl_stack_pop_values(cl_env_copy,v8);
          if (unwinding) ecl_unwind(cl_env_copy,next_fr);
          ECL_STACK_SET_INDEX(cl_env_copy,v7);
          ecl_bds_unwind1(cl_env_copy);
          ecl_bds_unwind1(cl_env_copy);
          }
         }
         ecl_stack_frame_push_values(v5);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         if (Null(ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7)))) { goto L78; }
         si_check_pending_interrupts();
L78:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v5);
        }
        ecl_stack_frame_close(_ecl_inner_frame);
       }
       ecl_frs_pop(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
       goto L47;
      }
L48:;
      {
       cl_object v4;
       v4 = ECL_CONS_CAR(CLV6);
       if (Null(v4)) {
       ecl_frs_pop(cl_env_copy); goto L47; }
       ecl_function_dispatch(cl_env_copy,VV[148])(1, ECL_NIL) /*  DM-TOO-MANY-ARGUMENTS */;
       ecl_frs_pop(cl_env_copy);
       goto L47;
      }
     }
    }
L47:;
    ECL_CONS_CAR(CLV5) = ecl_symbol_value(VV[42]);
    ecl_bds_unwind1(cl_env_copy);
    {
     cl_object v4output;
     value0 = ECL_CONS_CAR(CLV0);
     if ((value0)!=ECL_NIL) { goto L86; }
     if (!(ecl_boundp(cl_env_copy,VV[87]))) { goto L90; }
     value0 = cl_symbol_value(VV[87]);
     goto L88;
L90:;
     value0 = ECL_NIL;
     goto L88;
L88:;
     if ((value0)!=ECL_NIL) { goto L86; }
     {
      cl_object v5;
      v5 = ecl_make_cclosure_va((cl_objectfn)LC4031__lambda187,env2,Cblock,0);
      v4output = v5;
      goto L84;
     }
L86:;
     v4output = value0;
     goto L84;
L84:;
     cl_set(VV[87], ECL_NIL);
     si_gc(1, ECL_T);
     value0 = L4028compiler_output_values(v4output, ECL_CONS_CAR(CLV5));
     ecl_bds_unwind_n(cl_env_copy,11);
     return value0;
    }
   }
  }
 }
}
/*      closure LAMBDA135                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4029__lambda135(cl_narg narg, ...)
{
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV7 = env0;                                     /*  TAGBODY         */
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 {
  cl_object v1si__temp;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1si__temp = cl_grab_rest_args(args);
  ecl_va_end(args);
  ECL_CONS_CAR(CLV6) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV7),ecl_make_fixnum(0));
 }
 }
}
/*      closure LAMBDA176                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4030__lambda176(cl_narg narg, ...)
{
 cl_object T0;
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV7 = env0;
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);                           /*  SO-PATHNAME     */
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=0)) FEwrong_num_arguments_anonym();
 {
TTL:
  T0 = ECL_CONS_CAR(CLV1);
  ECL_CONS_CAR(CLV1) = ecl_function_dispatch(cl_env_copy,VV[154])(3, T0, ECL_CONS_CAR(CLV2), ecl_symbol_value(VV[47])) /*  SET-CLOSURE-ENV */;
  L4037compiler_pass1(1, ECL_CONS_CAR(CLV1));
  L4038compiler_pass_propagate_types();
  ecl_function_dispatch(cl_env_copy,VV[149])(2, ECL_NIL, ECL_CONS_CAR(CLV4)) /*  COMPILER-PASS/ASSEMBLE-CXX */;
  {
   cl_object v1;
   cl_object v2;
   v1 = ECL_NIL;
   {
    cl_object v3;
    v3 = ECL_CONS_CAR(CLV3);
    if (ecl_unlikely(!ECL_LISTP(v3))) FEtype_error_list(v3);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v2 = v3;
   }
L11:;
   if (!(ecl_endp(v2))) { goto L13; }
   goto L12;
L13:;
   v1 = ECL_CONS_CAR(v2);
   {
    cl_object v3;
    v3 = ECL_CONS_CDR(v2);
    if (ecl_unlikely(!ECL_LISTP(v3))) FEtype_error_list(v3);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v2 = v3;
   }
   ecl_function_dispatch(cl_env_copy,VV[86])(1, v1);
   goto L11;
L12:;
   goto L6;
  }
L6:;
  if (Null(cl_probe_file(ECL_CONS_CAR(CLV4)))) { goto L24; }
  cl_load(3, ECL_CONS_CAR(CLV4), ECL_SYM("VERBOSE",1360), ECL_NIL);
  value0 = ecl_function_dispatch(cl_env_copy,VV[86])(1, ECL_CONS_CAR(CLV4)) /*  CMP-DELETE-FILE */;
  return value0;
L24:;
  ECL_CONS_CAR(CLV0) = ECL_NIL;
  cl_set(VV[87], ECL_NIL);
  value0 = ecl_function_dispatch(cl_env_copy,VV[150])(2, VV[88], ECL_CONS_CAR(CLV0)) /*  CMPERR */;
  return value0;
 }
 }
}
/*      closure LAMBDA187                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4031__lambda187(cl_narg narg, ...)
{
 cl_object T0, T1, T2;
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV5 = env0;                                     /*  COMPILER-CONDITIONS */
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 {
  {
   cl_object v1c;
   cl_object v2;
   v1c = ECL_NIL;
   {
    cl_object v3;
    v3 = ECL_CONS_CAR(CLV5);
    if (ecl_unlikely(!ECL_LISTP(v3))) FEtype_error_list(v3);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v2 = v3;
   }
L5:;
   if (!(ecl_endp(v2))) { goto L7; }
   goto L6;
L7:;
   v1c = ECL_CONS_CAR(v2);
   {
    cl_object v3;
    v3 = ECL_CONS_CDR(v2);
    if (ecl_unlikely(!ECL_LISTP(v3))) FEtype_error_list(v3);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v2 = v3;
   }
   if (Null(si_of_class_p(2, v1c, VV[44]))) { goto L15; }
   T0 = (ECL_SYM("SIMPLE-PROGRAM-ERROR",1163)->symbol.gfdef);
   T1 = (cl_env_copy->function=(ECL_SYM("SIMPLE-CONDITION-FORMAT-CONTROL",770)->symbol.gfdef))->cfun.entry(1, v1c) /*  SIMPLE-CONDITION-FORMAT-CONTROL */;
   T2 = (cl_env_copy->function=(ECL_SYM("SIMPLE-CONDITION-FORMAT-ARGUMENTS",771)->symbol.gfdef))->cfun.entry(1, v1c) /*  SIMPLE-CONDITION-FORMAT-ARGUMENTS */;
   cl_apply(3, T0, T1, T2);
L15:;
   goto L5;
L6:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
 }
}
/*      function definition for DISASSEMBLE                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4036disassemble(volatile cl_narg narg, cl_object volatile v1thing, ...)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  ecl_va_list args; ecl_va_start(args,v1thing,narg,1);
  {
   cl_object keyvars[4];
   cl_parse_key(args,2,L4036disassemblekeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   env0 = ECL_NIL;
   CLV0 = env0 = CONS(keyvars[0],env0);           /*  H-FILE          */
   CLV1 = env0 = CONS(keyvars[1],env0);           /*  DATA-FILE       */
  }
  {
   volatile cl_object env1 = env0;
   CLV2 = env1 = CONS(ECL_NIL,env1);              /*  LEXENV          */
   CLV3 = env1 = CONS(ECL_NIL,env1);              /*  DISASSEMBLED-FORM */
   ecl_bds_push(cl_env_copy,VV[35]);              /*  *COMPILER-IN-USE* */
   ecl_bds_bind(cl_env_copy,ECL_SYM("*PRINT-PRETTY*",57),ECL_NIL); /*  *PRINT-PRETTY* */
   if (Null(si_valid_function_name_p(v1thing))) { goto L1; }
   v1thing = cl_fdefinition(v1thing);
L1:;
   if (Null(cl_functionp(v1thing))) { goto L4; }
   if (Null(cl_function_lambda_expression(v1thing))) { goto L4; }
   {
    cl_object v2;
    v2 = ECL_NIL;
    value0 = cl_function_lambda_expression(v1thing);
    {
     v2 = value0;
     ECL_CONS_CAR(CLV2) = cl_env_copy->values[1];
    }
    {
     cl_object v3;
     v3 = v2;
     value0 = ecl_make_bool(ECL_SYMBOLP(v3));
     if ((value0)!=ECL_NIL) { goto L20; }
     value0 = cl_functionp(v3);
     goto L18;
L20:;
     goto L18;
L18:;
     if ((value0)!=ECL_NIL) { goto L17; }
     T0 = ecl_make_bool(ECL_LISTP(v3));
     goto L15;
L17:;
     T0 = value0;
     goto L15;
L15:;
     if (ecl_unlikely(!((T0)!=ECL_NIL)))
         FEwrong_type_argument(VV[90],v3);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v1thing = v3;
    }
   }
   if (!((ECL_CONS_CAR(CLV2))==(ECL_T))) { goto L4; }
   (cl_env_copy->function=(ECL_SYM("WARN",905)->symbol.gfdef))->cfun.entry(1, VV[91]) /*  WARN */;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   ecl_bds_unwind1(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
L4:;
   {
    cl_object v2;
    v2 = ecl_make_bool(v1thing==ECL_NIL);
    if (Null(v2)) { goto L26; }
    goto L24;
L26:;
    if (Null(cl_functionp(v1thing))) { goto L28; }
    if ((si_bc_disassemble(v1thing))!=ECL_NIL) { goto L24; }
    (cl_env_copy->function=(ECL_SYM("WARN",905)->symbol.gfdef))->cfun.entry(2, VV[92], v1thing) /*  WARN */;
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    ecl_bds_unwind1(cl_env_copy);
    ecl_bds_unwind1(cl_env_copy);
    return value0;
L28:;
    if (!(ECL_ATOM(v1thing))) { goto L32; }
    T0 = ecl_list1(v1thing);
    cl_error(9, ECL_SYM("SIMPLE-TYPE-ERROR",775), ECL_SYM("DATUM",1242), v1thing, ECL_SYM("EXPECTED-TYPE",1260), VV[93], ECL_SYM("FORMAT-CONTROL",1269), VV[94], ECL_SYM("FORMAT-ARGUMENTS",1268), T0);
    goto L24;
L32:;
    T0 = ecl_car(v1thing);
    if (!((T0)==(ECL_SYM("LAMBDA",454)))) { goto L34; }
    T0 = ecl_cdr(v1thing);
    ECL_CONS_CAR(CLV3) = cl_listX(3, ECL_SYM("DEFUN",291), VV[87], T0);
    goto L24;
L34:;
    T0 = ecl_car(v1thing);
    if (!((T0)==(ECL_SYM("LAMBDA-BLOCK",1374)))) { goto L37; }
    T0 = ecl_cdr(v1thing);
    ECL_CONS_CAR(CLV3) = CONS(ECL_SYM("DEFUN",291),T0);
    goto L24;
L37:;
    T0 = ecl_list1(v1thing);
    cl_error(9, ECL_SYM("SIMPLE-TYPE-ERROR",775), ECL_SYM("DATUM",1242), v1thing, ECL_SYM("EXPECTED-TYPE",1260), VV[93], ECL_SYM("FORMAT-CONTROL",1269), VV[94], ECL_SYM("FORMAT-ARGUMENTS",1268), T0);
   }
L24:;
   {
    volatile cl_object v2null_stream;
    volatile cl_object v3compiler_conditions;
    volatile cl_object env2 = env1;
    v2null_stream = cl_make_broadcast_stream(0);
    ecl_bds_bind(cl_env_copy,VV[95],v2null_stream); /*  *COMPILER-OUTPUT1* */
    if (Null(ECL_CONS_CAR(CLV0))) { goto L43; }
    T0 = cl_open(5, ECL_CONS_CAR(CLV0), ECL_SYM("DIRECTION",1246), ECL_SYM("OUTPUT",1316), ECL_SYM("EXTERNAL-FORMAT",1264), ECL_SYM("DEFAULT",1243));
    goto L42;
L43:;
    T0 = v2null_stream;
L42:;
    ecl_bds_bind(cl_env_copy,VV[96],T0);          /*  *COMPILER-OUTPUT2* */
    T0 = cl_symbol_function(VV[97]);
    CLV4 = env2 = CONS(T0,env2);                  /*  T3LOCAL-FUN     */
    v3compiler_conditions = ECL_NIL;
    ecl_bds_push(cl_env_copy,VV[47]);             /*  *CMP-ENV-ROOT*  */
    ecl_bds_bind(cl_env_copy,VV[42],ECL_NIL);     /*  *COMPILER-CONDITIONS* */
    {
     volatile cl_object env3 = env2;
     CLV5 = env3 = CONS(ECL_NIL,env3);
     {
      volatile cl_object env4 = env3;
      CLV6 = env4 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env4); /*  TAGBODY */
      {
       ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV6));
       if (__ecl_frs_push_result) {
       if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L47;
       ecl_internal_error("GO found an inexistent tag");
       }
      }
      {
       cl_object volatile v4;
       v4 = ecl_make_cclosure_va((cl_objectfn)LC4033__lambda200,env4,Cblock,0);
       T0 = v4;
      }
      T1 = ecl_function_dispatch(cl_env_copy,VV[139])(4, ECL_SYM("NAME",1306), ECL_SYM("ABORT",79), ECL_SYM("FUNCTION",1270), T0) /*  MAKE-RESTART */;
      T2 = ecl_list1(T1);
      T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*RESTART-CLUSTERS*",5)));
      ecl_bds_bind(cl_env_copy,ECL_SYM("*RESTART-CLUSTERS*",5),T3); /*  *RESTART-CLUSTERS* */
      T0 = ecl_fdefinition(VV[140]);
      T1 = CONS(VV[43],T0);
      T2 = ecl_fdefinition(VV[141]);
      T3 = CONS(ECL_SYM("WARNING",906),T2);
      T4 = ecl_fdefinition(VV[142]);
      T5 = CONS(VV[44],T4);
      T6 = ecl_fdefinition(VV[143]);
      T7 = CONS(VV[45],T6);
      T8 = ecl_fdefinition(VV[143]);
      T9 = CONS(ECL_SYM("SERIOUS-CONDITION",744),T8);
      T10 = cl_list(5, T1, T3, T5, T7, T9);
      T11 = CONS(T10,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
      ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T11); /*  *HANDLER-CLUSTERS* */
      {
       volatile cl_object v4;
       v4 = ecl_symbol_value(ECL_SYM("+LOAD-COMPILE-LOCK+",1469));
       if (Null(mp_get_lock(2, v4, ECL_T))) {
       ecl_frs_pop(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
        goto L46;
       }
       {
        struct ecl_stack_frame _ecl_inner_frame_aux;
        volatile cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
        {
         volatile cl_object v5;
         v5 = _ecl_inner_frame;
         {
          volatile cl_object v6;
          v6 = ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7));
          ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),ECL_NIL); /*  *INTERRUPTS-ENABLED* */
          ecl_bds_bind(cl_env_copy,ECL_SYM("*ALLOW-WITH-INTERRUPTS*",1814),ECL_NIL); /*  *ALLOW-WITH-INTERRUPTS* */
          {
          volatile bool unwinding = FALSE;
          cl_index v7=ECL_STACK_INDEX(cl_env_copy),v8;
          ecl_frame_ptr next_fr;
          ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
          if (__ecl_frs_push_result) {
            unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
          } else {
          ecl_bds_bind(cl_env_copy,ECL_SYM("*INTERRUPTS-ENABLED*",7),v6); /*  *INTERRUPTS-ENABLED* */
          {
          volatile cl_object v9;
          volatile cl_object v10;
          volatile cl_object v11;
          volatile cl_object v12;
          volatile cl_object v13;
          v9 = cl_copy_tree(ecl_symbol_value(VV[47]));
          T0 = (ECL_SYM("EQUAL",337)->symbol.gfdef);
          v10 = cl_make_hash_table(4, ECL_SYM("SIZE",1342), ecl_make_fixnum(128), ECL_SYM("TEST",1350), T0);
          value0 = ecl_symbol_value(VV[49]);
          if ((value0)!=ECL_NIL) { goto L68; }
          v11 = ecl_symbol_value(VV[50]);
          goto L66;
L68:;
          v11 = value0;
          goto L66;
L66:;
          v12 = ecl_function_dispatch(cl_env_copy,VV[144])(1, ecl_symbol_value(VV[49])) /*  MAKE-OPTIMIZABLE-CONSTANTS */;
          {
          cl_object v14r;
          v14r = ecl_function_dispatch(cl_env_copy,VV[145])(1, ecl_symbol_value(VV[49])) /*  MACHINE-INLINE-INFORMATION */;
          if (Null(v14r)) { goto L73; }
          v13 = si_copy_hash_table(v14r);
          goto L71;
L73:;
          v13 = ecl_function_dispatch(cl_env_copy,VV[146])(1, ecl_symbol_value(VV[49])) /*  MAKE-INLINE-INFORMATION */;
          }
L71:;
          ecl_bds_bind(cl_env_copy,ECL_SYM("*GENSYM-COUNTER*",37),ecl_make_fixnum(0)); /*  *GENSYM-COUNTER* */
          ecl_bds_bind(cl_env_copy,VV[35],ECL_T); /*  *COMPILER-IN-USE* */
          ecl_bds_bind(cl_env_copy,VV[51],VV[46]); /*  *COMPILER-PHASE* */
          ecl_bds_bind(cl_env_copy,VV[52],ECL_NIL); /*  *CALLBACKS*   */
          ecl_bds_bind(cl_env_copy,VV[47],v9);    /*  *CMP-ENV-ROOT*  */
          ecl_bds_bind(cl_env_copy,VV[53],ECL_NIL); /*  *CMP-ENV*     */
          ecl_bds_bind(cl_env_copy,VV[54],v10);   /*  *LOAD-OBJECTS*  */
          ecl_bds_bind(cl_env_copy,VV[55],ECL_NIL); /*  *SETF-DEFINITIONS* */
          ecl_bds_bind(cl_env_copy,VV[56],ECL_NIL); /*  *MAKE-FORMS*  */
          ecl_bds_bind(cl_env_copy,VV[57],ECL_NIL); /*  *STATIC-CONSTANTS* */
          ecl_bds_bind(cl_env_copy,VV[58],ECL_NIL); /*  *PERMANENT-OBJECTS* */
          ecl_bds_bind(cl_env_copy,VV[59],ECL_NIL); /*  *TEMPORARY-OBJECTS* */
          ecl_bds_bind(cl_env_copy,VV[60],ECL_NIL); /*  *LOCAL-FUNS*  */
          ecl_bds_bind(cl_env_copy,VV[61],ECL_NIL); /*  *GLOBAL-VARS* */
          ecl_bds_bind(cl_env_copy,VV[62],ECL_NIL); /*  *GLOBAL-FUNS* */
          ecl_bds_bind(cl_env_copy,VV[63],ECL_NIL); /*  *GLOBAL-CFUNS-ARRAY* */
          ecl_bds_bind(cl_env_copy,VV[64],ECL_NIL); /*  *UNDEFINED-VARS* */
          ecl_bds_bind(cl_env_copy,VV[65],ECL_NIL); /*  *TOP-LEVEL-FORMS* */
          ecl_bds_bind(cl_env_copy,VV[66],ECL_NIL); /*  *COMPILE-TIME-TOO* */
          ecl_bds_bind(cl_env_copy,VV[67],ECL_NIL); /*  *CLINES-STRING-LIST* */
          ecl_bds_bind(cl_env_copy,VV[68],VV[48]); /*  *DEFUN-INLINE-HOOK* */
          ecl_bds_bind(cl_env_copy,VV[49],v11);   /*  *MACHINE*       */
          ecl_bds_bind(cl_env_copy,VV[69],v12);   /*  *OPTIMIZABLE-CONSTANTS* */
          ecl_bds_bind(cl_env_copy,VV[70],v13);   /*  *INLINE-INFORMATION* */
          {
          cl_object volatile v14;
          v14 = ecl_make_cclosure_va((cl_objectfn)LC4035__lambda241,env4,Cblock,0);
          T0 = v14;
          }
          cl_env_copy->values[0] = ecl_function_dispatch(cl_env_copy,VV[147])(1, T0) /*  DO-COMPILATION-UNIT */;
          ecl_bds_unwind_n(cl_env_copy,25);
          }
            next_fr = NULL;
          }
          ecl_frs_pop(cl_env_copy);
          v8=ecl_stack_push_values(cl_env_copy);
          mp_giveup_lock(v4);
          ecl_stack_pop_values(cl_env_copy,v8);
          if (unwinding) ecl_unwind(cl_env_copy,next_fr);
          ECL_STACK_SET_INDEX(cl_env_copy,v7);
          ecl_bds_unwind1(cl_env_copy);
          ecl_bds_unwind1(cl_env_copy);
          }
         }
         ecl_stack_frame_push_values(v5);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         if (Null(ecl_symbol_value(ECL_SYM("*INTERRUPTS-ENABLED*",7)))) { goto L77; }
         si_check_pending_interrupts();
L77:;cl_env_copy->values[0]=ecl_stack_frame_pop_values(v5);
        }
        ecl_stack_frame_close(_ecl_inner_frame);
       }
       ecl_frs_pop(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
       ecl_bds_unwind1(cl_env_copy);
       goto L46;
      }
L47:;
      {
       cl_object v4;
       v4 = ECL_CONS_CAR(CLV5);
       if (Null(v4)) {
       ecl_frs_pop(cl_env_copy); goto L46; }
       ecl_function_dispatch(cl_env_copy,VV[148])(1, ECL_NIL) /*  DM-TOO-MANY-ARGUMENTS */;
       ecl_frs_pop(cl_env_copy);
       goto L46;
      }
     }
    }
L46:;
    v3compiler_conditions = ecl_symbol_value(VV[42]);
    ecl_bds_unwind_n(cl_env_copy,4);
   }
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   ecl_bds_unwind1(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
  }
 }
}
/*      closure LAMBDA200                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4033__lambda200(cl_narg narg, ...)
{
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV6 = env0;                                     /*  TAGBODY         */
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 {
  cl_object v1si__temp;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1si__temp = cl_grab_rest_args(args);
  ecl_va_end(args);
  ECL_CONS_CAR(CLV5) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV6),ecl_make_fixnum(0));
 }
 }
}
/*      closure LAMBDA241                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4035__lambda241(volatile cl_narg narg, ...)
{
 cl_object T0, T1, T2;
 cl_object volatile CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile env0 = cl_env_copy->function->cclosure.env;
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV6 = env0;
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);                           /*  T3LOCAL-FUN     */
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=0)) FEwrong_num_arguments_anonym();
 {
TTL:
  ecl_bds_bind(cl_env_copy,VV[98],ecl_make_fixnum(0)); /*  *INLINE-BLOCKS* */
  ecl_bds_bind(cl_env_copy,VV[99],ecl_make_fixnum(0)); /*  *TEMP*     */
  ecl_bds_bind(cl_env_copy,VV[100],ecl_make_fixnum(0)); /*  *MAX-TEMP* */
  ecl_bds_bind(cl_env_copy,VV[101],ecl_make_fixnum(0)); /*  *NEXT-CFUN* */
  ecl_bds_bind(cl_env_copy,VV[102],ecl_make_fixnum(0)); /*  *LAST-LABEL* */
  T0 = ECL_CONS_CAR(CLV3);
  ECL_CONS_CAR(CLV3) = ecl_function_dispatch(cl_env_copy,VV[154])(3, T0, ECL_CONS_CAR(CLV2), ecl_symbol_value(VV[47])) /*  SET-CLOSURE-ENV */;
  {
   volatile bool unwinding = FALSE;
   cl_index v1=ECL_STACK_INDEX(cl_env_copy),v2;
   ecl_frame_ptr next_fr;
   ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
   if (__ecl_frs_push_result) {
     unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
   } else {
   {
    cl_object volatile v3;
    v3 = ecl_make_cclosure_va((cl_objectfn)LC4034__lambda251,env0,Cblock,0);
    T0 = v3;
   }
   si_fset(2, VV[97], T0);
   L4037compiler_pass1(1, ECL_CONS_CAR(CLV3));
   T0 = ecl_function_dispatch(cl_env_copy,VV[156])(3, VV[103], VV[104], VV[0]) /*  COMPUTE-INIT-NAME */;
   if (Null(ECL_CONS_CAR(CLV0))) { goto L9; }
   T1 = ECL_CONS_CAR(CLV0);
   goto L8;
L9:;
   T1 = VV[105];
L8:;
   if (Null(ECL_CONS_CAR(CLV1))) { goto L12; }
   T2 = ECL_CONS_CAR(CLV1);
   goto L11;
L12:;
   T2 = VV[105];
L11:;
   ecl_function_dispatch(cl_env_copy,VV[157])(3, T0, T1, T2) /*  CTOP-WRITE */;
   if (Null(ECL_CONS_CAR(CLV1))) { goto L14; }
   cl_env_copy->values[0] = ecl_function_dispatch(cl_env_copy,VV[158])(1, ECL_CONS_CAR(CLV1)) /*  DATA-C-DUMP */;
   goto L3;
L14:;
   cl_env_copy->values[0] = ECL_NIL;
   cl_env_copy->nvalues = 1;
L3:;
     next_fr = NULL;
   }
   ecl_frs_pop(cl_env_copy);
   v2=ecl_stack_push_values(cl_env_copy);
   si_fset(2, VV[97], ECL_CONS_CAR(CLV4));
   if (Null(ECL_CONS_CAR(CLV0))) { goto L16; }
   cl_close(1, ecl_symbol_value(VV[96]));
L16:;
   ecl_stack_pop_values(cl_env_copy,v2);
   if (unwinding) ecl_unwind(cl_env_copy,next_fr);
   ECL_STACK_SET_INDEX(cl_env_copy,v1);
   ecl_bds_unwind_n(cl_env_copy,5);
   return cl_env_copy->values[0];
  }
 }
 }
}
/*      closure LAMBDA251                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4034__lambda251(cl_narg narg, ...)
{
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV6 = env0;
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);                           /*  T3LOCAL-FUN     */
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 {
  cl_object v1args;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1args = cl_grab_rest_args(args);
  ecl_va_end(args);
  ecl_bds_bind(cl_env_copy,VV[95],ecl_symbol_value(ECL_SYM("*STANDARD-OUTPUT*",69))); /*  *COMPILER-OUTPUT1* */
  value0 = cl_apply(2, ECL_CONS_CAR(CLV4), v1args);
  ecl_bds_unwind1(cl_env_copy);
  return value0;
 }
 }
}
/*      function definition for COMPILER-PASS1                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4037compiler_pass1(cl_narg narg, cl_object v1object, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2source_offset;
  va_list args; va_start(args,v1object);
  {
   int i = 1;
   if (i >= narg) {
    v2source_offset = ECL_NIL;
   } else {
    i++;
    v2source_offset = va_arg(args,cl_object);
   }
  }
  va_end(args);
  ecl_function_dispatch(cl_env_copy,VV[160])(0)   /*  DATA-INIT       */;
  if (Null(cl_streamp(v1object))) { goto L4; }
  {
   cl_object v3form;
   ecl_bds_bind(cl_env_copy,VV[107],ecl_make_fixnum(0)); /*  *COMPILE-FILE-POSITION* */
   v3form = si_read_object_or_ignore(v1object, VV[33]);
   goto L9;
L8:;
   if (Null(v3form)) { goto L11; }
   {
    cl_object v4;
    v4 = ecl_symbol_value(ECL_SYM("*SOURCE-LOCATION*",1207));
    {
     cl_object v5;
     v5 = ecl_plus(v2source_offset,ecl_symbol_value(VV[107]));
     {
      cl_object v6;
      v6 = v4;
      if (ecl_unlikely(ECL_ATOM(v6))) FEtype_error_cons(v6);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T0 = v6;
     }
     (ECL_CONS_CDR(T0)=v5,T0);
    }
   }
   ecl_function_dispatch(cl_env_copy,VV[161])(1, v3form) /*  T1EXPR   */;
L11:;
   cl_set(VV[107],cl_file_position(1, v1object));
   v3form = si_read_object_or_ignore(v1object, VV[33]);
L9:;
   if ((v3form)==(VV[33])) { goto L24; }
   goto L8;
L24:;
   ecl_bds_unwind1(cl_env_copy);
   goto L3;
  }
L4:;
  ecl_function_dispatch(cl_env_copy,VV[161])(1, v1object) /*  T1EXPR  */;
L3:;
  cl_set(VV[65],cl_nreverse(ecl_symbol_value(VV[65])));
  cl_set(VV[56],cl_nreverse(ecl_symbol_value(VV[56])));
  value0 = ecl_symbol_value(VV[56]);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for COMPILER-PASS/PROPAGATE-TYPES         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4038compiler_pass_propagate_types()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_symbol_value(VV[109]))) { goto L1; }
  cl_set(VV[51],VV[110]);
  {
   cl_object v1;
   v1 = ecl_symbol_value(VV[65]);
   goto L8;
L7:;
   {
    cl_object v2form;
    v2form = ecl_car(v1);
    ecl_function_dispatch(cl_env_copy,VV[110])(1, v2form) /*  P1PROPAGATE */;
   }
   v1 = ecl_cdr(v1);
L8:;
   if (Null(v1)) { goto L15; }
   goto L7;
L15:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for PRINT-COMPILER-INFO                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L4039print_compiler_info()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[138])(5, VV[112], ecl_symbol_value(VV[113]), ecl_symbol_value(VV[114]), ecl_symbol_value(VV[115]), ecl_symbol_value(VV[116])) /*  CMPPROGRESS */;
  return value0;
 }
}
/*      local function WITH-COMPILATION-UNIT                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4040with_compilation_unit(cl_object v1, cl_object v2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4options;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[165])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4options = v5;
   }
   value0 = CONS(ECL_SYM("PROGN",673),v3);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      closure INSTALL-C-COMPILER                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC4041install_c_compiler(cl_narg narg, ...)
{
 cl_object T0;
 cl_object CLV0, CLV1, CLV2, CLV3;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV3 = env0;                                     /*  COMPILE-FILE-PATHNAME */
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=0)) FEwrong_num_arguments_anonym();
 {
TTL:
  T0 = cl_find_package(VV[120]);
  si_package_lock(T0, ECL_NIL);
  cl_set(ECL_SYM("*FEATURES*",36),cl_delete(2, VV[119], ecl_symbol_value(ECL_SYM("*FEATURES*",36))));
  si_fset(2, VV[106], ECL_CONS_CAR(CLV1));
  si_fset(2, VV[89], ECL_CONS_CAR(CLV0));
  si_fset(2, VV[74], ECL_CONS_CAR(CLV2));
  si_fset(2, VV[34], ECL_CONS_CAR(CLV3));
  T0 = cl_find_package(VV[120]);
  value0 = si_package_lock(T0, ECL_T);
  return value0;
 }
 }
}

#include "cmp/cmpmain.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclIeaWmFmPMfph9_GbZSyD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPMAIN.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclIeaWmFmPMfph9_GbZSyD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_package_lock(VVtemp[0], ECL_NIL);
  si_select_package(VVtemp[1]);
  ecl_cmp_defun(VV[122]);                         /*  COMPILE-FILE-PATHNAME */
  ecl_cmp_defun(VV[126]);                         /*  COMPILE-FILE    */
  ecl_cmp_defun(VV[151]);                         /*  COMPILER-OUTPUT-VALUES */
  si_Xmake_special(VV[76]);
  if (ecl_boundp(cl_env_copy,VV[76])) { goto L13; }
  cl_set(VV[76],ecl_make_fixnum(0));
L13:;
  ecl_cmp_defun(VV[152]);                         /*  COMPILE         */
  ecl_cmp_defun(VV[155]);                         /*  DISASSEMBLE     */
  ecl_cmp_defun(VV[159]);                         /*  COMPILER-PASS1  */
  ecl_cmp_defun(VV[162]);                         /*  COMPILER-PASS/PROPAGATE-TYPES */
  ecl_cmp_defun(VV[163]);                         /*  PRINT-COMPILER-INFO */
  ecl_cmp_defmacro(VV[164]);                      /*  WITH-COMPILATION-UNIT */
  si_package_lock(VVtemp[0], ECL_T);
  cl_set(ECL_SYM("*FEATURES*",36),cl_delete(2, VV[119], ecl_symbol_value(ECL_SYM("*FEATURES*",36))));
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  cl_object volatile CLV0, CLV1, CLV2, CLV3;
  {
   cl_object env1 = env0;
   T0 = (VV[89]->symbol.gfdef);
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(T0,env1);                   /*  COMPILE         */
   T0 = (VV[106]->symbol.gfdef);
   CLV1 = env1 = CONS(T0,env1);                   /*  DISASSEMBLE     */
   T0 = (VV[74]->symbol.gfdef);
   CLV2 = env1 = CONS(T0,env1);                   /*  COMPILE-FILE    */
   T0 = (VV[34]->symbol.gfdef);
   CLV3 = env1 = CONS(T0,env1);                   /*  COMPILE-FILE-PATHNAME */
   {
    cl_object v1;
    v1 = ecl_make_cclosure_va((cl_objectfn)LC4041install_c_compiler,env1,Cblock,0);
    T0 = v1;
   }
   si_fset(2, ECL_SYM("INSTALL-C-COMPILER",2076), T0);
  }
 }
  cl_provide(VV[121]);
}
