/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10/src/cmp/cmppass1-call.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmppass1-call.eclh"
/*      function definition for UNOPTIMIZED-LONG-CALL                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3464unoptimized_long_call(cl_object v1fun, cl_object v2arguments)
{
 cl_object T0, T1, T2, T3, T4, T5, T6;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = cl_gensym(0);
   v4 = cl_gensym(0);
   T0 = cl_list(2, v4, v1fun);
   T1 = ecl_list1(T0);
   {
    cl_object v5i;
    cl_object v6;
    v5i = ECL_NIL;
    {
     cl_object v7;
     v7 = v2arguments;
     if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v6 = v7;
    }
    {
     cl_object v7;
     cl_object v8;
     v7 = ecl_list1(ECL_NIL);
     v8 = v7;
L10:;
     if (!(ecl_endp(v6))) { goto L12; }
     goto L11;
L12:;
     v5i = ECL_CONS_CAR(v6);
     {
      cl_object v9;
      v9 = ECL_CONS_CDR(v6);
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v6 = v9;
     }
     {
      cl_object v9;
      v9 = v8;
      if (ecl_unlikely(ECL_ATOM(v9))) FEtype_error_cons(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T3 = v9;
     }
     T4 = cl_list(3, VV[1], v3, v5i);
     v8 = ecl_list1(T4);
     (ECL_CONS_CDR(T3)=v8,T3);
     goto L10;
L11:;
     T2 = ecl_cdr(v7);
     goto L3;
    }
   }
L3:;
   T3 = cl_list(3, ECL_SYM("APPLY-FROM-STACK-FRAME",1680), v3, v4);
   T4 = ecl_list1(T3);
   T5 = ecl_append(T2,T4);
   T6 = cl_listX(3, ECL_SYM("LET",479), T1, T5);
   value0 = cl_list(3, VV[0], v3, T6);
   return value0;
  }
 }
}
/*      function definition for UNOPTIMIZED-FUNCALL                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3465unoptimized_funcall(cl_object v1fun, cl_object v2arguments)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_fixnum v3l;
   v3l = ecl_length(v2arguments);
   if (!((v3l)<=(63))) { goto L2; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[41])(1, v1fun) /*  C1EXPR */;
   T1 = ecl_function_dispatch(cl_env_copy,VV[42])(1, v2arguments) /*  C1ARGS* */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[43])(8, ECL_SYM("FUNCALL",396), VV[3], ECL_T, VV[4], ECL_T, VV[5], T0, T1) /*  MAKE-C1FORM* */;
   return value0;
L2:;
   value0 = L3464unoptimized_long_call(v1fun, v2arguments);
   return value0;
  }
 }
}
/*      function definition for MACROEXPAND-LAMBDA-BLOCK              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3466macroexpand_lambda_block(cl_object v1lambda)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_car(v1lambda);
  if (!((T0)==(ECL_SYM("LAMBDA-BLOCK",1374)))) { goto L1; }
  value0 = cl_macroexpand_1(1, v1lambda);
  return value0;
L1:;
  value0 = v1lambda;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for C1FUNCALL                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3467c1funcall(cl_object v1args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[46])(3, ECL_SYM("FUNCALL",396), v1args, ecl_make_fixnum(1)) /*  CHECK-ARGS-NUMBER */;
  {
   cl_object v2;
   cl_object v3;
   cl_object v4fun;
   cl_object v5fd;
   v2 = ecl_car(v1args);
   v3 = ecl_cdr(v1args);
   v4fun = v2;
   v5fd = ECL_NIL;
   if (!(ECL_CONSP(v4fun))) { goto L6; }
   {
    cl_object v6;
    v6 = ecl_car(v4fun);
    if (!((v6)==(ECL_SYM("LAMBDA",454)))) { goto L13; }
    goto L10;
    goto L11;
L13:;
    goto L11;
L11:;
    if (!((v6)==(ECL_SYM("LAMBDA-BLOCK",1374)))) { goto L6; }
    goto L7;
L10:;
   }
L7:;
   T0 = L3466macroexpand_lambda_block(v4fun);
   value0 = L3479optimize_funcall_apply_lambda(T0, v3, ECL_NIL);
   return value0;
L6:;
   if (!(ECL_ATOM(v4fun))) { goto L16; }
   value0 = L3465unoptimized_funcall(v4fun, v3);
   return value0;
L16:;
   {
    cl_object v6name;
    v6name = ecl_car(v4fun);
    if (!(ECL_SYMBOLP(v6name))) { goto L23; }
    if ((v6name)==(ECL_SYM("THE",858))) { goto L23; }
    v5fd = ecl_function_dispatch(cl_env_copy,VV[47])(1, v6name) /*  CMP-MACRO-FUNCTION */;
    goto L21;
L23:;
    v5fd = ECL_NIL;
    goto L21;
L21:;
    if (Null(v5fd)) { goto L18; }
   }
   T0 = ecl_function_dispatch(cl_env_copy,VV[48])(2, v5fd, v4fun) /*  CMP-EXPAND-MACRO */;
   v1args = CONS(T0,v3);
   goto TTL;
L18:;
   T0 = ecl_car(v4fun);
   if ((T0)==(ECL_SYM("FUNCTION",398))) { goto L28; }
   value0 = L3465unoptimized_funcall(v4fun, v3);
   return value0;
L28:;
   v4fun = ecl_cadr(v4fun);
   if (Null(si_valid_function_name_p(v4fun))) { goto L30; }
   value0 = L3472c1call(v4fun, v3, ECL_NIL);
   return value0;
L30:;
   if (!(ECL_CONSP(v4fun))) { goto L33; }
   {
    cl_object v6;
    v6 = ecl_car(v4fun);
    if (!((v6)==(ECL_SYM("LAMBDA",454)))) { goto L40; }
    goto L37;
    goto L38;
L40:;
    goto L38;
L38:;
    if (!((v6)==(ECL_SYM("LAMBDA-BLOCK",1374)))) { goto L33; }
    goto L34;
L37:;
   }
L34:;
   T0 = L3466macroexpand_lambda_block(v4fun);
   value0 = L3479optimize_funcall_apply_lambda(T0, v3, ECL_NIL);
   return value0;
L33:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[49])(2, VV[10], v4fun) /*  CMPERR */;
   return value0;
  }
 }
}
/*      function definition for C1MULTIPLE-VALUE-CALL                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3468c1multiple_value_call(cl_object v1args)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2forms;
   v2forms = ECL_NIL;
   ecl_function_dispatch(cl_env_copy,VV[46])(3, ECL_SYM("MULTIPLE-VALUE-CALL",575), v1args, ecl_make_fixnum(1)) /*  CHECK-ARGS-NUMBER */;
   T0 = ecl_cdr(v1args);
   if (!(ecl_endp(T0))) { goto L3; }
   value0 = L3467c1funcall(v1args);
   return value0;
L3:;
   {
    cl_fixnum v3;
    v3 = ecl_length(v1args);
    if (!((v3)==(2))) { goto L5; }
   }
   v2forms = ecl_cadr(v1args);
   if (!(ECL_CONSP(v2forms))) { goto L5; }
   T0 = ecl_car(v2forms);
   if (!((ECL_SYM("VALUES",897))==(T0))) { goto L5; }
   T0 = ecl_car(v1args);
   T1 = ecl_cdr(v2forms);
   T2 = CONS(T0,T1);
   value0 = L3467c1funcall(T2);
   return value0;
L5:;
   {
    cl_object v3;
    cl_object v4;
    v3 = cl_gensym(0);
    v4 = cl_gensym(0);
    T0 = ecl_car(v1args);
    T1 = cl_list(2, v3, T0);
    T2 = ecl_list1(T1);
    {
     cl_object v5;
     cl_object v6i;
     cl_object v7;
     v5 = ecl_cdr(v1args);
     v6i = ECL_NIL;
     {
      cl_object v8;
      v8 = v5;
      if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v7 = v8;
     }
     {
      cl_object v8;
      cl_object v9;
      v8 = ecl_list1(ECL_NIL);
      v9 = v8;
L20:;
      if (!(ecl_endp(v7))) { goto L22; }
      goto L21;
L22:;
      v6i = ECL_CONS_CAR(v7);
      {
       cl_object v10;
       v10 = ECL_CONS_CDR(v7);
       if (ecl_unlikely(!ECL_LISTP(v10))) FEtype_error_list(v10);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v7 = v10;
      }
      {
       cl_object v10;
       v10 = v9;
       if (ecl_unlikely(ECL_ATOM(v10))) FEtype_error_cons(v10);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T4 = v10;
      }
      T5 = cl_list(3, VV[12], v4, v6i);
      v9 = ecl_list1(T5);
      (ECL_CONS_CDR(T4)=v9,T4);
      goto L20;
L21:;
      T3 = ecl_cdr(v8);
      goto L12;
     }
    }
L12:;
    T4 = cl_list(3, ECL_SYM("APPLY-FROM-STACK-FRAME",1680), v4, v3);
    T5 = ecl_list1(T4);
    T6 = ecl_append(T3,T5);
    T7 = cl_listX(3, ECL_SYM("LET*",480), T2, T6);
    value0 = cl_list(3, VV[0], v4, T7);
    return value0;
   }
  }
 }
}
/*      function definition for C1APPLY                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3470c1apply(cl_object v1args)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[46])(3, ECL_SYM("APPLY",91), v1args, ecl_make_fixnum(2)) /*  CHECK-ARGS-NUMBER */;
  {
   cl_object v2fun;
   cl_object v3arguments;
   v2fun = ecl_car(v1args);
   v3arguments = ecl_cdr(v1args);
   T0 = ecl_last(v3arguments,1);
   T1 = ecl_car(T0);
   if (!((T1)==(ECL_SYM(".COMBINED-METHOD-ARGS.",1544)))) { goto L4; }
   value0 = LC3469default_apply(v2fun, v3arguments);
   return value0;
L4:;
   if (!(ECL_CONSP(v2fun))) { goto L6; }
   {
    cl_object v4;
    v4 = ecl_car(v2fun);
    if (!((v4)==(ECL_SYM("LAMBDA",454)))) { goto L13; }
    goto L10;
    goto L11;
L13:;
    goto L11;
L11:;
    if (!((v4)==(ECL_SYM("LAMBDA-BLOCK",1374)))) { goto L6; }
    goto L7;
L10:;
   }
L7:;
   T0 = L3466macroexpand_lambda_block(v2fun);
   value0 = L3479optimize_funcall_apply_lambda(T0, v3arguments, ECL_T);
   return value0;
L6:;
   if (!(ECL_CONSP(v2fun))) { goto L16; }
   T0 = ecl_car(v2fun);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L16; }
   T0 = ecl_cadr(v2fun);
   if (!(ECL_CONSP(T0))) { goto L16; }
   {
    cl_object v4;
    v4 = ecl_caadr(v2fun);
    if (!((v4)==(ECL_SYM("LAMBDA",454)))) { goto L25; }
    goto L22;
    goto L23;
L25:;
    goto L23;
L23:;
    if (!((v4)==(ECL_SYM("LAMBDA-BLOCK",1374)))) { goto L16; }
    goto L17;
L22:;
   }
L17:;
   T0 = ecl_cadr(v2fun);
   v1args = CONS(T0,v3arguments);
   goto TTL;
L16:;
   value0 = LC3469default_apply(v2fun, v3arguments);
   return value0;
  }
 }
}
/*      local function DEFAULT-APPLY                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3469default_apply(cl_object v1fun, cl_object v2arguments)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3form;
   T0 = cl_listX(3, VV[14], v1fun, v2arguments);
   v3form = L3467c1funcall(T0);
   if (!(ECL_CONSP(v1fun))) { goto L2; }
   T0 = ecl_car(v1fun);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L2; }
   {
    cl_object v4fname;
    cl_object v5type;
    v4fname = ecl_cadr(v1fun);
    v5type = ecl_function_dispatch(cl_env_copy,VV[52])(1, v4fname) /*  GET-RETURN-TYPE */;
    if (Null(v5type)) { goto L2; }
    ecl_structure_set(v3form,VV[15],1,v5type);
   }
L2:;
   value0 = v3form;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for NOT-A-CLOSURE-P                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3471not_a_closure_p(cl_object v1fname)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(cl_fboundp(v1fname))) { goto L3; }
  {
   struct ecl_stack_frame _ecl_inner_frame_aux;
   cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
   {
    cl_object v2;
    v2 = _ecl_inner_frame;
    {
     cl_object v3;
     v3 = ECL_SYM("LIST",483);
     T2 = cl_fdefinition(v1fname);
     cl_env_copy->values[0] = cl_function_lambda_expression(T2);
     ecl_stack_frame_push_values(v2);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;cl_env_copy->values[0]=ecl_apply_from_stack_frame(v2,v3);
     value0 = cl_env_copy->values[0];
    }
   }
   ecl_stack_frame_close(_ecl_inner_frame);
  }
  T1 = value0;
  T0 = ecl_cadr(T1);
  goto L1;
L3:;
  T0 = ECL_NIL;
  goto L1;
L1:;
  value0 = Null(T0)?ECL_T:ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for C1CALL                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3472c1call(cl_object v1fname, cl_object v2args, cl_object v3macros_allowed)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4fd;
   cl_object v5success;
   cl_object v6can_inline;
   v4fd = ECL_NIL;
   v5success = ECL_NIL;
   v6can_inline = ECL_NIL;
   {
    cl_fixnum v7;
    v7 = ecl_length(v2args);
    if (!((v7)>(63))) { goto L4; }
   }
   if (Null(v3macros_allowed)) { goto L6; }
   v4fd = ecl_function_dispatch(cl_env_copy,VV[47])(1, v1fname) /*  CMP-MACRO-FUNCTION */;
   if (Null(v4fd)) { goto L6; }
   T0 = CONS(v1fname,v2args);
   value0 = ecl_function_dispatch(cl_env_copy,VV[48])(2, v4fd, T0) /*  CMP-EXPAND-MACRO */;
   return value0;
L6:;
   T0 = cl_list(2, ECL_SYM("FUNCTION",398), v1fname);
   value0 = L3464unoptimized_long_call(T0, v2args);
   return value0;
L4:;
   v4fd = ecl_function_dispatch(cl_env_copy,VV[54])(1, v1fname) /*  LOCAL-FUNCTION-REF */;
   if (Null(v4fd)) { goto L10; }
   value0 = L3474c1call_local(v1fname, v4fd, v2args);
   return value0;
L10:;
   if (Null(v3macros_allowed)) { goto L13; }
   v4fd = ecl_function_dispatch(cl_env_copy,VV[55])(1, v1fname) /*  CMP-ENV-SEARCH-MACRO */;
   if (Null(v4fd)) { goto L13; }
   T0 = CONS(v1fname,v2args);
   value0 = ecl_function_dispatch(cl_env_copy,VV[48])(2, v4fd, T0) /*  CMP-EXPAND-MACRO */;
   return value0;
L13:;
   v6can_inline = ecl_function_dispatch(cl_env_copy,VV[56])(1, v1fname) /*  INLINE-POSSIBLE */;
   if (Null(v6can_inline)) { goto L17; }
   v4fd = (cl_env_copy->function=(ECL_SYM("COMPILER-MACRO-FUNCTION",241)->symbol.gfdef))->cfun.entry(1, v1fname) /*  COMPILER-MACRO-FUNCTION */;
   if (Null(v4fd)) { goto L17; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[57])(3, v4fd, v1fname, v2args) /*  CMP-EXPAND-COMPILER-MACRO */;
   {
    const int v7 = cl_env_copy->nvalues;
    v4fd = value0;
    cl_object v8;
    v8 = (v7<=1)? ECL_NIL : cl_env_copy->values[1];
    v5success = v8;
   }
   if (Null(v5success)) { goto L17; }
   value0 = v4fd;
   cl_env_copy->nvalues = 1;
   return value0;
L17:;
   if (Null(v6can_inline)) { goto L25; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[58])(2, v1fname, v2args) /*  CLOS-COMPILER-MACRO-EXPAND */;
   {
    const int v7 = cl_env_copy->nvalues;
    v4fd = value0;
    cl_object v8;
    v8 = (v7<=1)? ECL_NIL : cl_env_copy->values[1];
    v5success = v8;
   }
   if (Null(v5success)) { goto L25; }
   value0 = v4fd;
   cl_env_copy->nvalues = 1;
   return value0;
L25:;
   if (Null(v3macros_allowed)) { goto L30; }
   v4fd = cl_macro_function(1, v1fname);
   if (Null(v4fd)) { goto L30; }
   T0 = CONS(v1fname,v2args);
   value0 = ecl_function_dispatch(cl_env_copy,VV[48])(2, v4fd, T0) /*  CMP-EXPAND-MACRO */;
   return value0;
L30:;
   v6can_inline = ecl_function_dispatch(cl_env_copy,VV[59])(1, v1fname) /*  DECLARED-INLINE-P */;
   if (Null(v6can_inline)) { goto L34; }
   if (!(ecl_plusp(ecl_symbol_value(VV[17])))) { goto L34; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[60])(1, ECL_SYM("SPACE",790)) /*  CMP-ENV-OPTIMIZATION */;
   if (!(ecl_lowereq(T0,ecl_make_fixnum(1)))) { goto L34; }
   {
    cl_object v7;
    cl_object v8;
    cl_object v9;
    v7 = ecl_symbol_value(VV[18]);
    v8 = ecl_fdefinition(VV[61]);
    v9 = ecl_fdefinition(VV[62]);
    {
     cl_object v10;
     v10 = ecl_function_dispatch(cl_env_copy,VV[63])(2, v7, ecl_make_fixnum(0)) /*  MAKE-SEQ-ITERATOR */;
L47:;
     if ((v10)!=ECL_NIL) { goto L49; }
     v4fd = ECL_NIL;
     goto L42;
L49:;
     {
      cl_object v11;
      v11 = ecl_function_dispatch(cl_env_copy,VV[64])(2, v7, v10) /*  SEQ-ITERATOR-REF */;
      T0 = ecl_function_dispatch(cl_env_copy,VV[61])(1, v11) /*  FUN-NAME */;
      if (Null(ecl_function_dispatch(cl_env_copy,VV[62])(2, v1fname, T0) /*  SAME-FNAME-P */)) { goto L51; }
      v4fd = v11;
      goto L42;
     }
L51:;
     v10 = ecl_function_dispatch(cl_env_copy,VV[65])(2, v7, v10) /*  SEQ-ITERATOR-NEXT */;
     goto L47;
    }
   }
L42:;
   if (Null(v4fd)) { goto L39; }
   if ((ecl_function_dispatch(cl_env_copy,VV[66])(1, v4fd) /*  FUN-CLOSURE */)!=ECL_NIL) { goto L39; }
   ecl_function_dispatch(cl_env_copy,VV[67])(2, VV[19], v1fname) /*  CMPNOTE */;
   T0 = ecl_function_dispatch(cl_env_copy,VV[68])(1, v4fd) /*  FUN-LAMBDA-EXPRESSION */;
   value0 = L3473inline_local(T0, v4fd, v2args);
   return value0;
L39:;
   if (!(ECL_CONSP(v6can_inline))) { goto L58; }
   if (Null(L3471not_a_closure_p(v1fname))) { goto L58; }
   T0 = ecl_car(v6can_inline);
   if (!((T0)==(ECL_SYM("FUNCTION",398)))) { goto L58; }
   T0 = ecl_one_minus(ecl_symbol_value(VV[17]));
   ecl_bds_bind(cl_env_copy,VV[17],T0);           /*  *INLINE-MAX-DEPTH* */
   ecl_function_dispatch(cl_env_copy,VV[67])(2, VV[19], v1fname) /*  CMPNOTE */;
   value0 = cl_listX(3, ECL_SYM("FUNCALL",396), v6can_inline, v2args);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
L58:;
   value0 = L3475c1call_global(v1fname, v2args);
   return value0;
L34:;
   value0 = L3475c1call_global(v1fname, v2args);
   return value0;
  }
 }
}
/*      function definition for INLINE-LOCAL                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3473inline_local(cl_object v1lambda, cl_object v2fun, cl_object v3args)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4;
   cl_object v5;
   cl_object v6;
   v4 = ecl_one_minus(ecl_symbol_value(VV[17]));
   v5 = ecl_symbol_value(VV[21]);
   v6 = ecl_function_dispatch(cl_env_copy,VV[69])(0) /*  CMP-ENV-COPY */;
   ecl_bds_bind(cl_env_copy,VV[17],v4);           /*  *INLINE-MAX-DEPTH* */
   ecl_bds_bind(cl_env_copy,VV[22],v6);           /*  *CMP-ENV*       */
   {
    cl_object v8;                                 /*  BINDINGS        */
    cl_object v9;                                 /*  BODY            */
    T0 = L3466macroexpand_lambda_block(v1lambda);
    value0 = L3478transform_funcall_apply_into_let_(T0, v3args, ECL_NIL);
    {
     const int v10 = cl_env_copy->nvalues;
     v8 = value0;
     cl_object v11;
     v11 = (v10<=1)? ECL_NIL : cl_env_copy->values[1];
     v9 = v11;
    }
    {
     cl_object v11;                               /*  LET-VARS        */
     cl_object v12;                               /*  LET-INITS       */
     cl_object v13;                               /*  SPECIALS        */
     cl_object v14;                               /*  OTHER-DECLS     */
     cl_object v15;                               /*  BODY            */
     value0 = ecl_function_dispatch(cl_env_copy,VV[70])(3, ECL_SYM("LET*",480), v8, v9) /*  PROCESS-LET-BINDINGS */;
     {
      const int v16 = cl_env_copy->nvalues;
      v11 = value0;
      cl_object v17;
      v17 = (v16<=1)? ECL_NIL : cl_env_copy->values[1];
      v12 = v17;
      v17 = (v16<=2)? ECL_NIL : cl_env_copy->values[2];
      v13 = v17;
      v17 = (v16<=3)? ECL_NIL : cl_env_copy->values[3];
      v14 = v17;
      v17 = (v16<=4)? ECL_NIL : cl_env_copy->values[4];
      v15 = v17;
     }
     T0 = ecl_function_dispatch(cl_env_copy,VV[71])(1, v2fun) /*  FUN-CMP-ENV */;
     T1 = ecl_function_dispatch(cl_env_copy,VV[69])(1, T0) /*  CMP-ENV-COPY */;
     ecl_bds_bind(cl_env_copy,VV[22],T1);         /*  *CMP-ENV*       */
     {
      cl_object v16;
      v16 = ecl_fdefinition(VV[72]);
      {
       cl_object v17;
       cl_object v18;
       v17 = ECL_NIL;
       {
        cl_object v19;
        v19 = v11;
        if (ecl_unlikely(!ECL_LISTP(v19))) FEtype_error_list(v19);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v18 = v19;
       }
L12:;
       if (!(ecl_endp(v18))) { goto L14; }
       goto L13;
L14:;
       v17 = ECL_CONS_CAR(v18);
       {
        cl_object v19;
        v19 = ECL_CONS_CDR(v18);
        if (ecl_unlikely(!ECL_LISTP(v19))) FEtype_error_list(v19);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v18 = v19;
       }
       ecl_function_dispatch(cl_env_copy,v16)(1, v17);
       goto L12;
L13:;
       goto L6;
      }
     }
L6:;
     value0 = ecl_function_dispatch(cl_env_copy,VV[73])(7, ECL_SYM("LET*",480), v11, v12, v13, v14, v15, v5) /*  PROCESS-LET-BODY */;
     ecl_bds_unwind1(cl_env_copy);
     ecl_bds_unwind1(cl_env_copy);
     ecl_bds_unwind1(cl_env_copy);
     return value0;
    }
   }
  }
 }
}
/*      function definition for C1CALL-LOCAL                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3474c1call_local(cl_object v1fname, cl_object v2fun, cl_object v3args)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4lambda;
   v4lambda = ecl_function_dispatch(cl_env_copy,VV[68])(1, v2fun) /*  FUN-LAMBDA-EXPRESSION */;
   if (Null(v4lambda)) { goto L1; }
   if (Null(ecl_function_dispatch(cl_env_copy,VV[59])(1, v1fname) /*  DECLARED-INLINE-P */)) { goto L1; }
   if (!(ecl_plusp(ecl_symbol_value(VV[17])))) { goto L1; }
   value0 = L3473inline_local(v4lambda, v2fun, v3args);
   return value0;
  }
L1:;
  {
   cl_object v4forms;
   cl_object v5return_type;
   cl_object v6arg_types;
   v4forms = ecl_function_dispatch(cl_env_copy,VV[42])(1, v3args) /*  C1ARGS* */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[74])(1, v2fun) /*  GET-LOCAL-RETURN-TYPE */;
   if ((value0)!=ECL_NIL) { goto L9; }
   v5return_type = ECL_T;
   goto L7;
L9:;
   v5return_type = value0;
   goto L7;
L7:;
   v6arg_types = ecl_function_dispatch(cl_env_copy,VV[75])(1, v2fun) /*  GET-LOCAL-ARG-TYPES */;
   if (Null(v6arg_types)) { goto L12; }
   {
    cl_object v7fl;
    v7fl = ECL_NIL;
    {
     cl_object v8;
     v8 = v4forms;
     goto L19;
L18:;
     {
      cl_object v9form;
      v9form = ecl_car(v8);
      if (!(ecl_endp(v6arg_types))) { goto L24; }
      v7fl = CONS(v9form,v7fl);
      goto L23;
L24:;
      T0 = ecl_car(v6arg_types);
      T1 = ecl_car(v3args);
      T2 = ecl_function_dispatch(cl_env_copy,VV[76])(6, T0, v9form, T1, VV[23], VV[24], v1fname) /*  AND-FORM-TYPE */;
      v7fl = CONS(T2,v7fl);
      {
       cl_object v10;
       v10 = v6arg_types;
       {
        cl_object v11;
        v11 = v10;
        {
         bool v12;
         v12 = ECL_LISTP(v11);
         if (ecl_unlikely(!(v12)))
         FEwrong_type_argument(VV[25],v11);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
        }
       }
       if (Null(v10)) { goto L34; }
       {
        cl_object v11;
        v11 = ECL_CONS_CDR(v10);
        v6arg_types = v11;
        v10 = ECL_CONS_CAR(v10);
       }
L34:;
      }
      {
       cl_object v10;
       v10 = v3args;
       {
        cl_object v11;
        v11 = v10;
        {
         bool v12;
         v12 = ECL_LISTP(v11);
         if (ecl_unlikely(!(v12)))
         FEwrong_type_argument(VV[25],v11);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
        }
       }
       if (Null(v10)) { goto L44; }
       {
        cl_object v11;
        v11 = ECL_CONS_CDR(v10);
        v3args = v11;
        v10 = ECL_CONS_CAR(v10);
       }
L44:;
      }
L23:;
     }
     v8 = ecl_cdr(v8);
L19:;
     if (Null(v8)) { goto L52; }
     goto L18;
L52:;
    }
    v4forms = cl_nreverse(v7fl);
   }
L12:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[43])(10, VV[26], VV[3], ECL_T, VV[4], ECL_T, ECL_SYM("TYPE",1353), v5return_type, VV[5], v2fun, v4forms) /*  MAKE-C1FORM* */;
   return value0;
  }
 }
}
/*      function definition for C1CALL-GLOBAL                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3475c1call_global(cl_object v1fname, cl_object v2args)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3forms;
   v3forms = ecl_function_dispatch(cl_env_copy,VV[42])(1, v2args) /*  C1ARGS* */;
   {
    cl_object v4value;
    v4value = L3477c1call_constant_fold(v1fname, v3forms);
    if (Null(v4value)) { goto L2; }
    value0 = v4value;
    cl_env_copy->nvalues = 1;
    return value0;
   }
L2:;
   T0 = ecl_function_dispatch(cl_env_copy,VV[78])(1, v1fname) /*  FUNCTION-MAY-CHANGE-SP */;
   T1 = ecl_function_dispatch(cl_env_copy,VV[79])(1, v1fname) /*  FUNCTION-MAY-HAVE-SIDE-EFFECTS */;
   T2 = ecl_function_dispatch(cl_env_copy,VV[80])(2, v1fname, v3forms) /*  PROPAGATE-TYPES */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[43])(10, VV[27], VV[3], T0, VV[4], T1, ECL_SYM("TYPE",1353), T2, VV[5], v1fname, v3forms) /*  MAKE-C1FORM* */;
   return value0;
  }
 }
}
/*      function definition for C1CALL-CONSTANT-FOLD                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3477c1call_constant_fold(cl_object volatile v1fname, cl_object volatile v2forms)
{
 cl_object T0, T1, T2, T3;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(si_get_sysprop(v1fname, VV[29]))) { goto L1; }
  if (Null(ecl_function_dispatch(cl_env_copy,VV[82])(0) /*  POLICY-EVALUATE-FORMS */)) { goto L1; }
  if (Null(ecl_function_dispatch(cl_env_copy,VV[56])(1, v1fname) /*  INLINE-POSSIBLE */)) { goto L1; }
  {
   volatile cl_object env1 = env0;
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(ECL_NIL,env1);
   {
    volatile cl_object env2 = env1;
    CLV1 = env2 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env2); /*  TAGBODY */
    {
     ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV1));
     if (__ecl_frs_push_result) {
     if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L5;
     ecl_internal_error("GO found an inexistent tag");
     }
    }
    {
     cl_object v3;
     v3 = ecl_make_cclosure_va((cl_objectfn)LC3476__lambda103,env2,Cblock,1);
     T0 = v3;
    }
    T1 = CONS(ECL_SYM("ERROR",339),T0);
    T2 = ecl_list1(T1);
    T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
    ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T3); /*  *HANDLER-CLUSTERS* */
    {
     cl_object v3all_values;
     v3all_values = ECL_NIL;
     {
      cl_object v4constant_p;
      v4constant_p = ECL_NIL;
      {
       cl_object v5v;
       v5v = ECL_NIL;
       {
        cl_object v6form;
        cl_object v7;
        v6form = ECL_NIL;
        {
         cl_object v8;
         v8 = v2forms;
         if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v7 = v8;
        }
L15:;
        if (!(ecl_endp(v7))) { goto L17; }
        goto L16;
L17:;
        v6form = ECL_CONS_CAR(v7);
        {
         cl_object v8;
         v8 = ECL_CONS_CDR(v7);
         if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v7 = v8;
        }
        value0 = ecl_function_dispatch(cl_env_copy,VV[83])(1, v6form) /*  C1FORM-CONSTANT-P */;
        {
         const int v8 = cl_env_copy->nvalues;
         v4constant_p = value0;
         cl_object v9;
         v9 = (v8<=1)? ECL_NIL : cl_env_copy->values[1];
         v5v = v9;
        }
        if (Null(value0)) { goto L26; }
        v3all_values = CONS(v5v,v3all_values);
        goto L25;
L26:;
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 1;
        ecl_frs_pop(cl_env_copy);
        ecl_bds_unwind1(cl_env_copy);
        return value0;
L25:;
        goto L15;
L16:;
        {
         cl_object v8results;
         {
          struct ecl_stack_frame _ecl_inner_frame_aux;
          cl_object _ecl_inner_frame = ecl_stack_frame_open(cl_env_copy,(cl_object)&_ecl_inner_frame_aux,0);
          {
          cl_object v9;
          v9 = _ecl_inner_frame;
          {
          cl_object v10;
          v10 = ECL_SYM("LIST",483);
          T0 = cl_nreverse(v3all_values);
          cl_env_copy->values[0] = cl_apply(2, v1fname, T0);
          ecl_stack_frame_push_values(v9);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;cl_env_copy->values[0]=ecl_apply_from_stack_frame(v9,v10);
          value0 = cl_env_copy->values[0];
          }
          }
          ecl_stack_frame_close(_ecl_inner_frame);
         }
         v8results = value0;
         T0 = ecl_cdr(v8results);
         if (!(ecl_endp(T0))) { goto L38; }
         T0 = ecl_car(v8results);
         value0 = ecl_function_dispatch(cl_env_copy,VV[84])(1, T0) /*  C1CONSTANT-VALUE */;
         ecl_frs_pop(cl_env_copy);
         ecl_bds_unwind1(cl_env_copy);
         return value0;
L38:;
         {
          cl_object v9results;
          {
          cl_object v10;
          v10 = ecl_fdefinition(VV[84]);
          {
          cl_object v11;
          cl_object v12;
          v11 = ECL_NIL;
          {
          cl_object v13;
          v13 = v8results;
          if (ecl_unlikely(!ECL_LISTP(v13))) FEtype_error_list(v13);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          v12 = v13;
          }
          {
          cl_object v13;
          cl_object v14;
          v13 = ecl_list1(ECL_NIL);
          v14 = v13;
L48:;
          if (!(ecl_endp(v12))) { goto L50; }
          goto L49;
L50:;
          v11 = ECL_CONS_CAR(v12);
          {
          cl_object v15;
          v15 = ECL_CONS_CDR(v12);
          if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          v12 = v15;
          }
          {
          cl_object v15;
          v15 = v14;
          if (ecl_unlikely(ECL_ATOM(v15))) FEtype_error_cons(v15);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          T0 = v15;
          }
          T1 = ecl_function_dispatch(cl_env_copy,v10)(1, v11);
          v14 = ecl_list1(T1);
          (ECL_CONS_CDR(T0)=v14,T0);
          goto L48;
L49:;
          v9results = ecl_cdr(v13);
          goto L40;
          }
          }
          }
L40:;
          T0 = (ECL_SYM("IDENTITY",428)->symbol.gfdef);
          if (Null(cl_every(2, T0, v9results))) { goto L66; }
          value0 = ecl_function_dispatch(cl_env_copy,VV[43])(3, ECL_SYM("VALUES",897), VV[5], v9results) /*  MAKE-C1FORM* */;
          ecl_frs_pop(cl_env_copy);
          ecl_bds_unwind1(cl_env_copy);
          return value0;
L66:;
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 1;
          ecl_frs_pop(cl_env_copy);
          ecl_bds_unwind1(cl_env_copy);
          return value0;
         }
        }
       }
      }
     }
    }
L5:;
    {
     cl_object v3c;
     v3c = ECL_CONS_CAR(CLV0);
     value0 = ecl_function_dispatch(cl_env_copy,VV[85])(4, VV[30], v1fname, v2forms, v3c) /*  CMPDEBUG */;
     ecl_frs_pop(cl_env_copy);
     return value0;
    }
   }
  }
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      closure LAMBDA103                                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3476__lambda103(cl_narg narg, cl_object v1si__temp, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  TAGBODY         */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  ECL_CONS_CAR(CLV0) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV1),ecl_make_fixnum(0));
 }
 }
}
/*      function definition for TRANSFORM-FUNCALL/APPLY-INTO-LET*     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3478transform_funcall_apply_into_let_(cl_object v1lambda_form, cl_object v2arguments, cl_object v3apply_p)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4apply_list;
   cl_object v5apply_var;
   cl_object v6let_vars;
   cl_object v7extra_stmts;
   cl_object v8all_keys;
   v4apply_list = ECL_NIL;
   v5apply_var = ECL_NIL;
   v6let_vars = ECL_NIL;
   v7extra_stmts = ECL_NIL;
   v8all_keys = ECL_NIL;
   {
    cl_object v10;                                /*  REQUIREDS       */
    cl_object v11;                                /*  OPTIONALS       */
    cl_object v12;                                /*  REST            */
    cl_object v13;                                /*  KEY-FLAG        */
    cl_object v14;                                /*  KEYWORDS        */
    cl_object v15;                                /*  ALLOW-OTHER-KEYS */
    cl_object v16;                                /*  AUX-VARS        */
    T0 = ecl_cadr(v1lambda_form);
    value0 = ecl_function_dispatch(cl_env_copy,VV[87])(1, T0) /*  CMP-PROCESS-LAMBDA-LIST */;
    {
     const int v17 = cl_env_copy->nvalues;
     v10 = value0;
     cl_object v18;
     v18 = (v17<=1)? ECL_NIL : cl_env_copy->values[1];
     v11 = v18;
     v18 = (v17<=2)? ECL_NIL : cl_env_copy->values[2];
     v12 = v18;
     v18 = (v17<=3)? ECL_NIL : cl_env_copy->values[3];
     v13 = v18;
     v18 = (v17<=4)? ECL_NIL : cl_env_copy->values[4];
     v14 = v18;
     v18 = (v17<=5)? ECL_NIL : cl_env_copy->values[5];
     v15 = v18;
     v18 = (v17<=6)? ECL_NIL : cl_env_copy->values[6];
     v16 = v18;
    }
    if (Null(v3apply_p)) { goto L7; }
    T0 = ecl_last(v2arguments,1);
    v4apply_list = ecl_car(T0);
    v5apply_var = cl_gensym(0);
    v2arguments = ecl_butlast(v2arguments,1);
L7:;
    {
     cl_object v17n_args_wanted_min;
     cl_object v18n_args_wanted_max;
     cl_object v19apply_constant_args_p;
     cl_object v20n_args_got_min;
     cl_object v21n_args_got_max;
     v17n_args_wanted_min = ecl_car(v10);
     if ((v13)!=ECL_NIL) { goto L19; }
     if ((v15)!=ECL_NIL) { goto L19; }
     if (Null(v12)) { goto L17; }
     goto L18;
L19:;
L18:;
     v18n_args_wanted_max = ecl_make_fixnum(65536);
     goto L16;
L17:;
     T0 = ecl_car(v10);
     T1 = ecl_car(v11);
     v18n_args_wanted_max = ecl_plus(T0,T1);
L16:;
     if (Null(v3apply_p)) { goto L24; }
     if (Null(cl_constantp(1, v4apply_list))) { goto L24; }
     T0 = ecl_function_dispatch(cl_env_copy,ECL_SYM("CONSTANT-FORM-VALUE",2152))(1, v4apply_list) /*  CONSTANT-FORM-VALUE */;
     v19apply_constant_args_p = ecl_make_bool(ECL_LISTP(T0));
     goto L22;
L24:;
     v19apply_constant_args_p = ECL_NIL;
     goto L22;
L22:;
     if (Null(v19apply_constant_args_p)) { goto L28; }
     {
      cl_fixnum v22;
      v22 = ecl_length(v2arguments);
      T0 = ecl_function_dispatch(cl_env_copy,ECL_SYM("CONSTANT-FORM-VALUE",2152))(1, v4apply_list) /*  CONSTANT-FORM-VALUE */;
      {
       cl_fixnum v23;
       v23 = ecl_length(T0);
       v20n_args_got_min = ecl_plus(ecl_make_fixnum(v22),ecl_make_fixnum(v23));
       goto L27;
      }
     }
L28:;
     v20n_args_got_min = ecl_make_fixnum(ecl_length(v2arguments));
L27:;
     if (Null(v3apply_p)) { goto L31; }
     if ((v19apply_constant_args_p)!=ECL_NIL) { goto L31; }
     v21n_args_got_max = ECL_NIL;
     goto L30;
L31:;
     v21n_args_got_max = v20n_args_got_min;
L30:;
     if (Null(v21n_args_got_max)) { goto L34; }
     if (!(ecl_lower(v21n_args_got_max,v17n_args_wanted_min))) { goto L34; }
     ecl_function_dispatch(cl_env_copy,VV[88])(3, v1lambda_form, v17n_args_wanted_min, v20n_args_got_min) /*  TOO-FEW-ARGS */;
L34:;
     if (!(ecl_greater(v20n_args_got_min,v18n_args_wanted_max))) { goto L14; }
     ecl_function_dispatch(cl_env_copy,VV[89])(3, v1lambda_form, v18n_args_wanted_max, v21n_args_got_max) /*  TOO-MANY-ARGS */;
    }
L14:;
    v2arguments = cl_copy_list(v2arguments);
    {
     cl_object v17scan;
     v17scan = v2arguments;
     goto L44;
L43:;
     {
      cl_object v18form;
      v18form = ecl_car(v17scan);
      if ((cl_constantp(1, v18form))!=ECL_NIL) { goto L46; }
      {
       cl_object v19aux_var;
       v19aux_var = cl_gensym(0);
       T0 = cl_list(2, v19aux_var, v18form);
       v6let_vars = CONS(T0,v6let_vars);
       {
        cl_object v20;
        v20 = v19aux_var;
        {
         cl_object v21;
         v21 = v17scan;
         if (ecl_unlikely(ECL_ATOM(v21))) FEtype_error_cons(v21);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         T0 = v21;
        }
        (ECL_CONS_CAR(T0)=v20,T0);
       }
      }
     }
L46:;
     v17scan = ecl_cdr(v17scan);
L44:;
     if (ecl_endp(v17scan)) { goto L59; }
     goto L43;
L59:;
    }
    if (Null(v5apply_var)) { goto L61; }
    T0 = cl_list(2, v5apply_var, v4apply_list);
    v6let_vars = CONS(T0,v6let_vars);
L61:;
    {
     cl_object v17;
     v17 = ecl_cdr(v10);
     goto L68;
L67:;
     {
      cl_object v18i;
      v18i = ecl_car(v17);
      if (Null(v2arguments)) { goto L75; }
      {
       cl_object v19;
       v19 = v2arguments;
       {
        cl_object v20;
        v20 = v19;
        {
         bool v21;
         v21 = ECL_LISTP(v20);
         if (ecl_unlikely(!(v21)))
         FEwrong_type_argument(VV[25],v20);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
        }
       }
       if (Null(v19)) { goto L81; }
       {
        cl_object v20;
        v20 = ECL_CONS_CDR(v19);
        v2arguments = v20;
        v19 = ECL_CONS_CAR(v19);
       }
L81:;
       T0 = v19;
       goto L74;
      }
L75:;
      if (Null(v3apply_p)) { goto L87; }
      T1 = cl_list(2, ECL_SYM("POP",645), v5apply_var);
      T0 = cl_list(4, ECL_SYM("IF",948), v5apply_var, T1, VV[32]);
      goto L74;
L87:;
      T0 = ECL_NIL;
L74:;
      T1 = cl_list(2, v18i, T0);
      v6let_vars = CONS(T1,v6let_vars);
     }
     v17 = ecl_cdr(v17);
L68:;
     if (Null(v17)) { goto L91; }
     goto L67;
L91:;
    }
    {
     cl_object v17scan;
     v17scan = ecl_cdr(v11);
     goto L97;
L96:;
     {
      cl_object v18;
      cl_object v19;
      cl_object v20;
      v18 = ecl_car(v17scan);
      v19 = ecl_caddr(v17scan);
      v20 = ecl_cadr(v17scan);
      if (Null(v2arguments)) { goto L103; }
      {
       cl_object v21;
       v21 = v2arguments;
       {
        cl_object v22;
        v22 = v21;
        {
         bool v23;
         v23 = ECL_LISTP(v22);
         if (ecl_unlikely(!(v23)))
         FEwrong_type_argument(VV[25],v22);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
        }
       }
       if (Null(v21)) { goto L111; }
       {
        cl_object v22;
        v22 = ECL_CONS_CDR(v21);
        v2arguments = v22;
        v21 = ECL_CONS_CAR(v21);
       }
L111:;
       T0 = v21;
      }
      T1 = cl_list(2, v18, T0);
      T2 = cl_list(2, v19, ECL_T);
      v6let_vars = cl_listX(3, T1, T2, v6let_vars);
      goto L99;
L103:;
      if (Null(v3apply_p)) { goto L117; }
      T0 = cl_list(2, ECL_SYM("POP",645), v5apply_var);
      T1 = cl_list(4, ECL_SYM("IF",948), v5apply_var, T0, v20);
      T2 = cl_list(2, v18, T1);
      T3 = cl_list(2, v19, v5apply_var);
      v6let_vars = cl_listX(3, T2, T3, v6let_vars);
      goto L99;
L117:;
      T0 = cl_list(2, v18, v20);
      T1 = cl_list(2, v19, ECL_NIL);
      v6let_vars = cl_listX(3, T0, T1, v6let_vars);
     }
L99:;
     v17scan = ecl_cdddr(v17scan);
L97:;
     if (ecl_endp(v17scan)) { goto L123; }
     goto L96;
L123:;
    }
    if ((v13)!=ECL_NIL) { goto L127; }
    if (Null(v15)) { goto L125; }
    goto L126;
L127:;
L126:;
    if ((v12)!=ECL_NIL) { goto L125; }
    v12 = cl_gensym(0);
L125:;
    if (Null(v12)) { goto L132; }
    if (Null(v2arguments)) { goto L136; }
    if (Null(v3apply_p)) { goto L138; }
    T1 = ecl_list1(v5apply_var);
    T2 = ecl_append(v2arguments,T1);
    T0 = CONS(ECL_SYM("LIST*",484),T2);
    goto L135;
L138:;
    T0 = CONS(ECL_SYM("LIST",483),v2arguments);
    goto L135;
L136:;
    if (Null(v3apply_p)) { goto L140; }
    T0 = v5apply_var;
    goto L135;
L140:;
    T0 = ECL_NIL;
L135:;
    T1 = cl_list(2, v12, T0);
    v6let_vars = CONS(T1,v6let_vars);
    goto L131;
L132:;
    if (Null(v3apply_p)) { goto L131; }
    T0 = cl_list(3, ECL_SYM("WHEN",907), v5apply_var, VV[33]);
    v7extra_stmts = CONS(T0,v7extra_stmts);
L131:;
    {
     cl_object v17scan;
     v17scan = ecl_cdr(v14);
     goto L148;
L147:;
     {
      cl_object v18;
      cl_object v19;
      cl_object v20;
      cl_object v21;
      v18 = ecl_car(v17scan);
      v19 = ecl_cadr(v17scan);
      v20 = ecl_caddr(v17scan);
      value0 = ecl_cadddr(v17scan);
      if ((value0)!=ECL_NIL) { goto L156; }
      v21 = cl_gensym(0);
      goto L154;
L156:;
      v21 = value0;
      goto L154;
L154:;
      v8all_keys = CONS(v18,v8all_keys);
      T0 = cl_list(3, ECL_SYM("EQ",335), v21, VV[34]);
      if (Null(ecl_cadddr(v17scan))) { goto L162; }
      T1 = cl_list(3, ECL_SYM("SETF",752), v21, ECL_NIL);
      goto L161;
L162:;
      T1 = ECL_NIL;
L161:;
      T2 = cl_list(3, ECL_SYM("PROG1",671), v20, T1);
      if (Null(ecl_cadddr(v17scan))) { goto L165; }
      T3 = cl_list(3, ECL_SYM("SETF",752), v21, ECL_T);
      goto L164;
L165:;
      T3 = ECL_NIL;
L164:;
      T4 = cl_list(3, ECL_SYM("PROG1",671), v21, T3);
      T5 = cl_list(4, ECL_SYM("IF",948), T0, T2, T4);
      T6 = cl_list(2, v19, T5);
      T7 = cl_list(3, VV[35], v12, v18);
      T8 = cl_list(2, v21, T7);
      v6let_vars = cl_listX(3, T6, T8, v6let_vars);
     }
     v17scan = ecl_cddddr(v17scan);
L148:;
     if (ecl_endp(v17scan)) { goto L169; }
     goto L147;
L169:;
    }
    if (Null(v13)) { goto L171; }
    if ((v15)!=ECL_NIL) { goto L171; }
    T0 = cl_list(2, ECL_SYM("QUOTE",681), v8all_keys);
    T1 = cl_list(3, VV[36], v12, T0);
    v7extra_stmts = CONS(T1,v7extra_stmts);
L171:;
    {
     cl_object v17;
     v17 = v16;
     {
      cl_object v18;
      v18 = v17;
      {
       bool v19;
       v19 = ECL_LISTP(v18);
       if (ecl_unlikely(!(v19)))
         FEwrong_type_argument(VV[25],v18);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
      }
     }
     if (Null(v17)) { goto L180; }
     {
      cl_object v18;
      v18 = ECL_CONS_CDR(v17);
      v16 = v18;
      v17 = ECL_CONS_CAR(v17);
     }
L180:;
    }
L187:;
    if ((v16)!=ECL_NIL) { goto L189; }
    goto L188;
L189:;
    {
     cl_object v17;
     v17 = v16;
     {
      cl_object v18;
      v18 = v17;
      {
       bool v19;
       v19 = ECL_LISTP(v18);
       if (ecl_unlikely(!(v19)))
         FEwrong_type_argument(VV[25],v18);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
      }
     }
     if (Null(v17)) { goto L198; }
     {
      cl_object v18;
      v18 = ECL_CONS_CDR(v17);
      v16 = v18;
      v17 = ECL_CONS_CAR(v17);
     }
L198:;
     T0 = v17;
    }
    {
     cl_object v17;
     v17 = v16;
     {
      cl_object v18;
      v18 = v17;
      {
       bool v19;
       v19 = ECL_LISTP(v18);
       if (ecl_unlikely(!(v19)))
         FEwrong_type_argument(VV[25],v18);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
      }
     }
     if (Null(v17)) { goto L209; }
     {
      cl_object v18;
      v18 = ECL_CONS_CDR(v17);
      v16 = v18;
      v17 = ECL_CONS_CAR(v17);
     }
L209:;
     T1 = v17;
    }
    T2 = cl_list(2, T0, T1);
    v6let_vars = CONS(T2,v6let_vars);
    goto L187;
L188:;
    T0 = (ECL_SYM("FIRST",373)->symbol.gfdef);
    T1 = cl_delete_if_not(2, T0, v6let_vars);
    T2 = cl_nreverse(T1);
    if (Null(v5apply_var)) { goto L219; }
    T4 = cl_list(2, ECL_SYM("IGNORABLE",429), v5apply_var);
    T5 = cl_list(2, ECL_SYM("DECLARE",276), T4);
    T3 = ecl_list1(T5);
    goto L217;
L219:;
    T3 = ECL_NIL;
    goto L217;
L217:;
    {
     cl_object v18;                               /*  DECL            */
     cl_object v19;                               /*  BODY            */
     T5 = ecl_cddr(v1lambda_form);
     value0 = ecl_function_dispatch(cl_env_copy,VV[90])(1, T5) /*  FIND-DECLARATIONS */;
     {
      const int v20 = cl_env_copy->nvalues;
      v18 = value0;
      cl_object v21;
      v21 = (v20<=1)? ECL_NIL : cl_env_copy->values[1];
      v19 = v21;
     }
     T4 = cl_append(3, v18, v7extra_stmts, v19);
    }
    T5 = ecl_append(T3,T4);
    cl_env_copy->nvalues = 2;
    cl_env_copy->values[1] = T5;
    cl_env_copy->values[0] = T2;
    return cl_env_copy->values[0];
   }
  }
 }
}
/*      function definition for OPTIMIZE-FUNCALL/APPLY-LAMBDA         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3479optimize_funcall_apply_lambda(cl_object v1lambda_form, cl_object v2arguments, cl_object v3apply_p)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v5;                                  /*  BINDINGS        */
   cl_object v6;                                  /*  BODY            */
   value0 = L3478transform_funcall_apply_into_let_(v1lambda_form, v2arguments, v3apply_p);
   {
    const int v7 = cl_env_copy->nvalues;
    v5 = value0;
    cl_object v8;
    v8 = (v7<=1)? ECL_NIL : cl_env_copy->values[1];
    v6 = v8;
   }
   value0 = cl_listX(3, ECL_SYM("LET*",480), v5, v6);
   return value0;
  }
 }
}

#include "cmp/cmppass1-call.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclAiEafgbcZUqr9_LqSSyD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPPASS1-CALL.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclAiEafgbcZUqr9_LqSSyD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  ecl_cmp_defun(VV[39]);                          /*  UNOPTIMIZED-LONG-CALL */
  ecl_cmp_defun(VV[40]);                          /*  UNOPTIMIZED-FUNCALL */
  ecl_cmp_defun(VV[44]);                          /*  MACROEXPAND-LAMBDA-BLOCK */
  ecl_cmp_defun(VV[45]);                          /*  C1FUNCALL       */
  ecl_cmp_defun(VV[50]);                          /*  C1MULTIPLE-VALUE-CALL */
  ecl_cmp_defun(VV[51]);                          /*  C1APPLY         */
  (void)0; /* No entry created for NOT-A-CLOSURE-P */
  ecl_cmp_defun(VV[53]);                          /*  C1CALL          */
  (void)0; /* No entry created for INLINE-LOCAL */
  (void)0; /* No entry created for C1CALL-LOCAL */
  ecl_cmp_defun(VV[77]);                          /*  C1CALL-GLOBAL   */
  ecl_cmp_defun(VV[81]);                          /*  C1CALL-CONSTANT-FOLD */
  ecl_cmp_defun(VV[86]);                          /*  TRANSFORM-FUNCALL/APPLY-INTO-LET* */
  ecl_cmp_defun(VV[91]);                          /*  OPTIMIZE-FUNCALL/APPLY-LAMBDA */
}
