/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10/src/cmp/cmpbackend-cxx/cmpc-opt-ct.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmpc-opt-ct.eclh"
/*      function definition for MAKE-SINGLE-CONSTANT-OPTIMIZER        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3692make_single_constant_optimizer(cl_object v1name, cl_object v2c_value)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_SYMBOLP(v1name))) { goto L1; }
  {
   cl_object v3value;
   cl_object v4type;
   v3value = cl_symbol_value(v1name);
   T0 = cl_type_of(v3value);
   v4type = ecl_function_dispatch(cl_env_copy,VV[61])(1, T0) /*  LISP-TYPE->REP-TYPE */;
   T0 = cl_listX(6, ECL_SYM("C-INLINE",2097), ECL_NIL, ECL_NIL, v4type, v2c_value, VV[0]);
   value0 = CONS(v3value,T0);
   cl_env_copy->nvalues = 1;
   return value0;
  }
L1:;
  if (!(floatp(v1name))) { goto L5; }
  {
   cl_object v5type;
   cl_object v6loc_type;
   cl_object v7location;
   v5type = cl_type_of(v1name);
   if (!((v5type)==(ECL_SYM("SINGLE-FLOAT",780)))) { goto L9; }
   v6loc_type = VV[1];
   goto L8;
L9:;
   if (!((v5type)==(ECL_SYM("DOUBLE-FLOAT",317)))) { goto L11; }
   v6loc_type = VV[2];
   goto L8;
L11:;
   if (!((v5type)==(ECL_SYM("LONG-FLOAT",510)))) { goto L13; }
   v6loc_type = VV[3];
   goto L8;
L13:;
   if (!((v5type)==(ECL_SYM("COMPLEX-SINGLE-FLOAT",1892)))) { goto L15; }
   v6loc_type = VV[4];
   goto L8;
L15:;
   if (!((v5type)==(ECL_SYM("COMPLEX-DOUBLE-FLOAT",1893)))) { goto L17; }
   v6loc_type = VV[5];
   goto L8;
L17:;
   if (!((v5type)==(ECL_SYM("COMPLEX-LONG-FLOAT",1894)))) { goto L19; }
   v6loc_type = VV[6];
   goto L8;
L19:;
   v6loc_type = ECL_NIL;
L8:;
   v7location = ecl_function_dispatch(cl_env_copy,VV[62])(4, ECL_SYM("LOCATION",1001), v2c_value, ECL_SYM("VALUE",2066), v1name) /*  MAKE-VV */;
   T0 = cl_list(3, v6loc_type, v1name, v7location);
   T1 = ecl_function_dispatch(cl_env_copy,VV[63])(5, VV[7], ECL_SYM("TYPE",1353), v5type, VV[8], T0) /*  MAKE-C1FORM* */;
   value0 = CONS(v1name,T1);
   cl_env_copy->nvalues = 1;
   return value0;
  }
L5:;
  T0 = cl_type_of(v1name);
  T1 = ecl_function_dispatch(cl_env_copy,VV[62])(4, ECL_SYM("LOCATION",1001), v2c_value, ECL_SYM("VALUE",2066), v1name) /*  MAKE-VV */;
  T2 = ecl_function_dispatch(cl_env_copy,VV[63])(5, VV[7], ECL_SYM("TYPE",1353), T0, VV[8], T1) /*  MAKE-C1FORM* */;
  value0 = CONS(v1name,T2);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for MAKE-OPTIMIZABLE-CONSTANTS            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3693make_optimizable_constants(cl_object v1machine)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   cl_object v3value;
   cl_object v4name;
   cl_object v5;
   v2 = L3694optimizable_constants_list(v1machine);
   v3value = ECL_NIL;
   v4name = ECL_NIL;
   {
    cl_object v6;
    v6 = v2;
    if (ecl_unlikely(!ECL_LISTP(v6))) FEtype_error_list(v6);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v5 = v6;
   }
   {
    cl_object v6;
    cl_object v7;
    v6 = ecl_list1(ECL_NIL);
    v7 = v6;
L9:;
    if (!(ecl_endp(v5))) { goto L11; }
    goto L10;
L11:;
    {
     cl_object v8;
     v8 = ECL_CONS_CAR(v5);
     v3value = ecl_car(v8);
     v8 = ecl_cdr(v8);
     v4name = ecl_car(v8);
    }
    {
     cl_object v8;
     v8 = ECL_CONS_CDR(v5);
     if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v5 = v8;
    }
    {
     cl_object v8;
     v8 = v7;
     if (ecl_unlikely(ECL_ATOM(v8))) FEtype_error_cons(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     T0 = v8;
    }
    T1 = L3692make_single_constant_optimizer(v3value, v4name);
    v7 = ecl_list1(T1);
    (ECL_CONS_CDR(T0)=v7,T0);
    goto L9;
L10:;
    value0 = ecl_cdr(v6);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for OPTIMIZABLE-CONSTANTS-LIST            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3694optimizable_constants_list(cl_object v1machine)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!((v1machine)==(ecl_symbol_value(VV[38])))) { goto L2; }
  T1 = ecl_append(VV[57],VV[58]);
  T0 = cl_listX(19, VV[39], VV[40], VV[41], VV[42], VV[43], VV[44], VV[45], VV[46], VV[47], VV[48], VV[49], VV[50], VV[51], VV[52], VV[53], VV[54], VV[55], VV[56], T1);
  goto L1;
L2:;
  T0 = ECL_NIL;
L1:;
  value0 = ecl_append(VV[11],T0);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}

#include "cmp/cmpc-opt-ct.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclJXNVsxOEGfup9_UUVSyD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPBACKEND-CXX;CMPC-OPT-CT.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclJXNVsxOEGfup9_UUVSyD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  ecl_cmp_defun(VV[60]);                          /*  MAKE-SINGLE-CONSTANT-OPTIMIZER */
  ecl_cmp_defun(VV[64]);                          /*  MAKE-OPTIMIZABLE-CONSTANTS */
  VV[11]= CONS(ECL_NIL,ECL_NIL);
  VV[13]= CONS(ECL_NIL,ECL_NIL);
  VV[15]= CONS(ECL_NIL,ECL_NIL);
  VV[17]= CONS(ECL_NIL,ECL_NIL);
  VV[19]= CONS(ECL_NIL,ECL_NIL);
  VV[21]= CONS(ECL_NIL,ECL_NIL);
  VV[23]= CONS(ECL_NIL,ECL_NIL);
  VV[24]= CONS(ECL_NIL,ECL_NIL);
  (ECL_CONS_CAR(VV[24])=cl_core.lisp_package,VV[24]);
  (ECL_CONS_CDR(VV[24])=VV[25],VV[24]);
  VV[26]= CONS(ECL_NIL,ECL_NIL);
  VV[27]= CONS(ECL_NIL,ECL_NIL);
  (ECL_CONS_CAR(VV[27])=cl_core.user_package,VV[27]);
  (ECL_CONS_CDR(VV[27])=VV[28],VV[27]);
  VV[29]= CONS(ECL_NIL,ECL_NIL);
  VV[30]= CONS(ECL_NIL,ECL_NIL);
  (ECL_CONS_CAR(VV[30])=cl_core.keyword_package,VV[30]);
  (ECL_CONS_CDR(VV[30])=VV[31],VV[30]);
  VV[32]= CONS(ECL_NIL,ECL_NIL);
  VV[33]= CONS(ECL_NIL,ECL_NIL);
  (ECL_CONS_CAR(VV[33])=cl_core.clos_package,VV[33]);
  (ECL_CONS_CDR(VV[33])=VV[34],VV[33]);
  VV[35]= CONS(ECL_NIL,ECL_NIL);
  VV[36]= CONS(ECL_NIL,ECL_NIL);
  (ECL_CONS_CAR(VV[36])=cl_core.mp_package,VV[36]);
  (ECL_CONS_CDR(VV[36])=VV[37],VV[36]);
  (ECL_CONS_CAR(VV[35])=VV[36],VV[35]);
  (ECL_CONS_CDR(VV[35])=ECL_NIL,VV[35]);
  (ECL_CONS_CAR(VV[32])=VV[33],VV[32]);
  (ECL_CONS_CDR(VV[32])=VV[35],VV[32]);
  (ECL_CONS_CAR(VV[29])=VV[30],VV[29]);
  (ECL_CONS_CDR(VV[29])=VV[32],VV[29]);
  (ECL_CONS_CAR(VV[26])=VV[27],VV[26]);
  (ECL_CONS_CDR(VV[26])=VV[29],VV[26]);
  (ECL_CONS_CAR(VV[23])=VV[24],VV[23]);
  (ECL_CONS_CDR(VV[23])=VV[26],VV[23]);
  (ECL_CONS_CAR(VV[21])=VV[22],VV[21]);
  (ECL_CONS_CDR(VV[21])=VV[23],VV[21]);
  (ECL_CONS_CAR(VV[19])=VV[20],VV[19]);
  (ECL_CONS_CDR(VV[19])=VV[21],VV[19]);
  (ECL_CONS_CAR(VV[17])=VV[18],VV[17]);
  (ECL_CONS_CDR(VV[17])=VV[19],VV[17]);
  (ECL_CONS_CAR(VV[15])=VV[16],VV[15]);
  (ECL_CONS_CDR(VV[15])=VV[17],VV[15]);
  (ECL_CONS_CAR(VV[13])=VV[14],VV[13]);
  (ECL_CONS_CDR(VV[13])=VV[15],VV[13]);
  (ECL_CONS_CAR(VV[11])=VV[12],VV[11]);
  (ECL_CONS_CDR(VV[11])=VV[13],VV[11]);
  ecl_cmp_defun(VV[65]);                          /*  OPTIMIZABLE-CONSTANTS-LIST */
}
