/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10/src/cmp/cmppass1-stack.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmppass1-stack.eclh"
/*      function definition for C1WITH-STACK                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3423c1with_stack(cl_object v1forms)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2var;
   cl_object v3body;
   {
    cl_object v4;
    v4 = v1forms;
    {
     cl_object v5;
     v5 = v4;
     {
      bool v6;
      v6 = ECL_LISTP(v5);
      if (ecl_unlikely(!(v6)))
         FEwrong_type_argument(VV[0],v5);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
     }
    }
    if (Null(v4)) { goto L6; }
    {
     cl_object v5;
     v5 = ECL_CONS_CDR(v4);
     v1forms = v5;
     v4 = ECL_CONS_CAR(v4);
    }
L6:;
    v2var = v4;
   }
   T0 = cl_list(2, v2var, VV[1]);
   T1 = ecl_list1(T0);
   T2 = cl_listX(3, ECL_SYM("LET",479), T1, v1forms);
   v3body = ecl_function_dispatch(cl_env_copy,VV[18])(1, T2) /*  C1EXPR */;
   T0 = ecl_function_dispatch(cl_env_copy,VV[19])(1, v3body) /*  C1FORM-TYPE */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[20])(5, VV[2], ECL_SYM("TYPE",1353), T0, VV[3], v3body) /*  MAKE-C1FORM* */;
   return value0;
  }
 }
}
/*      function definition for C1INNERMOST-STACK-FRAME               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3424c1innermost_stack_frame(cl_object v1args)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = VV[5];
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for C1STACK-PUSH                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3425c1stack_push(cl_object v1args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_listX(3, ECL_SYM("C-INLINE",2097), v1args, VV[7]);
  value0 = cl_list(3, ECL_SYM("PROGN",673), T0, ecl_make_fixnum(1));
  return value0;
 }
}
/*      function definition for C1STACK-PUSH-VALUES                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3426c1stack_push_values(cl_object v1args)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   cl_object v3;
   {
    cl_object v4;
    v4 = v1args;
    {
     cl_object v5;
     v5 = v4;
     {
      bool v6;
      v6 = ECL_LISTP(v5);
      if (ecl_unlikely(!(v6)))
         FEwrong_type_argument(VV[0],v5);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
     }
    }
    if (Null(v4)) { goto L6; }
    {
     cl_object v5;
     v5 = ECL_CONS_CDR(v4);
     v1args = v5;
     v4 = ECL_CONS_CAR(v4);
    }
L6:;
    v2 = v4;
   }
   {
    cl_object v4;
    v4 = v1args;
    {
     cl_object v5;
     v5 = v4;
     {
      bool v6;
      v6 = ECL_LISTP(v5);
      if (ecl_unlikely(!(v6)))
         FEwrong_type_argument(VV[0],v5);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
     }
    }
    if (Null(v4)) { goto L17; }
    {
     cl_object v5;
     v5 = ECL_CONS_CDR(v4);
     v1args = v5;
     v4 = ECL_CONS_CAR(v4);
    }
L17:;
    v3 = v4;
   }
   T0 = ecl_function_dispatch(cl_env_copy,VV[18])(1, v3) /*  C1EXPR   */;
   T1 = ecl_list1(v2);
   T2 = cl_listX(3, ECL_SYM("C-INLINE",2097), T1, VV[11]);
   T3 = ecl_function_dispatch(cl_env_copy,VV[18])(1, T2) /*  C1EXPR   */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[20])(6, VV[9], ECL_SYM("TYPE",1353), VV[10], VV[3], T0, T3) /*  MAKE-C1FORM* */;
   return value0;
  }
 }
}
/*      function definition for C1STACK-POP                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3427c1stack_pop(cl_object v1args)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = cl_listX(3, ECL_SYM("C-INLINE",2097), v1args, VV[13]);
  return value0;
 }
}
/*      function definition for C1APPLY-FROM-STACK-FRAME              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3428c1apply_from_stack_frame(cl_object v1args)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = cl_listX(3, ECL_SYM("C-INLINE",2097), v1args, VV[15]);
  return value0;
 }
}

#include "cmp/cmppass1-stack.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _ecl7eN3MvLwnm1r9_5PSSyD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPPASS1-STACK.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_ecl7eN3MvLwnm1r9_5PSSyD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  ecl_cmp_defun(VV[17]);                          /*  C1WITH-STACK    */
  ecl_cmp_defun(VV[21]);                          /*  C1INNERMOST-STACK-FRAME */
  ecl_cmp_defun(VV[22]);                          /*  C1STACK-PUSH    */
  ecl_cmp_defun(VV[23]);                          /*  C1STACK-PUSH-VALUES */
  ecl_cmp_defun(VV[24]);                          /*  C1STACK-POP     */
  ecl_cmp_defun(VV[25]);                          /*  C1APPLY-FROM-STACK-FRAME */
}
