/*      Compiler: ECL 24.5.10                                         */
/*      Source: /builddir/build/BUILD/ecl-24.5.10/src/lsp/autoload.lsp */
#include <ecl/ecl-cmp.h>
#include "lsp/autoload.eclh"
/*      function definition for LISP-IMPLEMENTATION-TYPE              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
cl_object cl_lisp_implementation_type()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = VV[0];
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for AUTOLOAD                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L776autoload(cl_narg narg, cl_object v1pathname, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2si__function_names;
  ecl_va_list args; ecl_va_start(args,v1pathname,narg,1);
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v1pathname,env0);            /*  PATHNAME        */
  v2si__function_names = cl_grab_rest_args(args);
  ecl_va_end(args);
  {
   cl_object v3;
   v3 = v2si__function_names;
   goto L4;
L3:;
   {
    cl_object v4si__fname;
    v4si__fname = ecl_car(v3);
    {
     cl_object env1 = env0;
     CLV1 = env1 = CONS(v4si__fname,env1);        /*  THENAME         */
     {
      cl_object v5;
      v5 = ecl_make_cclosure_va((cl_objectfn)LC775__lambda3,env1,Cblock,0);
      T0 = v5;
     }
     si_fset(2, v4si__fname, T0);
    }
   }
   v3 = ecl_cdr(v3);
L4:;
   if (Null(v3)) { goto L12; }
   goto L3;
L12:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      closure LAMBDA3                                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC775__lambda3(cl_narg narg, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  THENAME         */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 {
  cl_object v1si__args;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1si__args = cl_grab_rest_args(args);
  ecl_va_end(args);
  cl_load(1, ECL_CONS_CAR(CLV0));
  value0 = cl_apply(2, ECL_CONS_CAR(CLV1), v1si__args);
  return value0;
 }
 }
}
/*      local function PROCLAIM                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC777proclaim(cl_object v1si__d)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_car(v1si__d);
  if (!((T0)==(ECL_SYM("SPECIAL",791)))) { goto L1; }
  {
   cl_object v2;
   v2 = (ECL_SYM("*MAKE-SPECIAL",1029)->symbol.gfdef);
   {
    cl_object v3;
    v3 = ecl_cdr(v1si__d);
    {
     cl_object v4;
     cl_object v5;
     v4 = ECL_NIL;
     {
      cl_object v6;
      v6 = v3;
      if (ecl_unlikely(!ECL_LISTP(v6))) FEtype_error_list(v6);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v5 = v6;
     }
L9:;
     if (!(ecl_endp(v5))) { goto L11; }
     goto L10;
L11:;
     v4 = ECL_CONS_CAR(v5);
     {
      cl_object v6;
      v6 = ECL_CONS_CDR(v5);
      if (ecl_unlikely(!ECL_LISTP(v6))) FEtype_error_list(v6);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v5 = v6;
     }
     ecl_function_dispatch(cl_env_copy,v2)(1, v4);
     goto L9;
L10:;
     value0 = v3;
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function WITH-COMPILATION-UNIT                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC778with_compilation_unit(cl_object v1, cl_object v2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4si__options;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[15])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4si__options = v5;
   }
   value0 = CONS(ECL_SYM("PROGN",673),v3);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for ED-EXTERNAL                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L779ed_external(cl_object v1si__x)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (v1si__x==ECL_NIL) { goto L3; }
  if ((cl_pathnamep(v1si__x))!=ECL_NIL) { goto L3; }
  if (!(ECL_STRINGP(v1si__x))) { goto L1; }
  goto L2;
L3:;
L2:;
  value0 = si_getenv(VV[3]);
  if ((value0)!=ECL_NIL) { goto L9; }
  T0 = VV[4];
  goto L7;
L9:;
  T0 = value0;
  goto L7;
L7:;
  if (Null(v1si__x)) { goto L13; }
  T1 = ecl_list1(v1si__x);
  goto L11;
L13:;
  T1 = ECL_NIL;
  goto L11;
L11:;
  si_run_program(2, T0, T1);
  value0 = ECL_T;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for ED                                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L780ed(cl_narg narg, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg>1)) FEwrong_num_arguments_anonym();
 {
  cl_object v1si__x;
  va_list args; va_start(args,narg);
  {
   int i = 0;
   if (i >= narg) {
    v1si__x = ECL_NIL;
   } else {
    i++;
    v1si__x = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v2;
   v2 = ecl_symbol_value(ECL_SYM("*ED-FUNCTIONS*",1122));
   goto L5;
L4:;
   {
    cl_object v3si__fun;
    v3si__fun = ecl_car(v2);
    if (Null(ecl_function_dispatch(cl_env_copy,v3si__fun)(1, v1si__x))) { goto L9; }
    value0 = ECL_T;
    cl_env_copy->nvalues = 1;
    return value0;
L9:;
   }
   v2 = ecl_cdr(v2);
L5:;
   if (Null(v2)) { goto L13; }
   goto L4;
L13:;
   value0 = cl_error(2, VV[6], v1si__x);
   return value0;
  }
 }
}
/*      function definition for ROOM                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L781room(cl_narg narg, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg>1)) FEwrong_num_arguments_anonym();
 {
  cl_object v1si__x;
  va_list args; va_start(args,narg);
  {
   int i = 0;
   if (i >= narg) {
    v1si__x = ECL_NIL;
   } else {
    i++;
    v1si__x = va_arg(args,cl_object);
   }
  }
  va_end(args);
  cl_format(2, ECL_T, VV[8]);
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 0;
  return value0;
 }
}
/*      function definition for HELP                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L782help(cl_narg narg, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg>1)) FEwrong_num_arguments_anonym();
 {
  cl_object v1symbol;
  va_list args; va_start(args,narg);
  {
   int i = 0;
   if (i >= narg) {
    v1symbol = VV[12];
   } else {
    i++;
    v1symbol = va_arg(args,cl_object);
   }
  }
  va_end(args);
  value0 = ecl_function_dispatch(cl_env_copy,VV[20])(1, v1symbol) /*  PRINT-DOC */;
  return value0;
 }
}

#include "lsp/autoload.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _ecl3WFL2k0m36Hi9_6u8SyD71(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:LSP;AUTOLOAD.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_ecl3WFL2k0m36Hi9_6u8SyD71@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  (void)0; /* No entry created for LISP-IMPLEMENTATION-TYPE */
  ecl_cmp_defun(VV[13]);                          /*  AUTOLOAD        */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  if ((cl_fboundp(ECL_SYM("COMPILE",235)))!=ECL_NIL) { goto L8; }
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun((cl_objectfn_fixed)LC777proclaim,ECL_NIL,Cblock,1);
   T0 = v1;
  }
  si_fset(2, ECL_SYM("PROCLAIM",668), T0);
L8:;
 }
  ecl_cmp_defmacro(VV[14]);                       /*  WITH-COMPILATION-UNIT */
  (cl_env_copy->function=(ECL_SYM("MAPC",545)->symbol.gfdef))->cfun.entry(2, ECL_SYM("PROCLAIM",668), VVtemp[1]) /*  MAPC */;
  ecl_cmp_defun(VV[16]);                          /*  ED-EXTERNAL     */
  (cl_env_copy->function=(ECL_SYM("MAPC",545)->symbol.gfdef))->cfun.entry(2, ECL_SYM("PROCLAIM",668), VVtemp[2]) /*  MAPC */;
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  si_Xmake_special(ECL_SYM("*ED-FUNCTIONS*",1122));
  if (ecl_boundp(cl_env_copy,ECL_SYM("*ED-FUNCTIONS*",1122))) { goto L23; }
  T0 = (VV[5]->symbol.gfdef);
  cl_set(ECL_SYM("*ED-FUNCTIONS*",1122),ecl_list1(T0));
L23:;
 }
  ecl_cmp_defun(VV[17]);                          /*  ED              */
  ecl_cmp_defun(VV[18]);                          /*  ROOM            */
  L776autoload(3, VVtemp[3], VV[10], VV[11]);
  ecl_cmp_defun(VV[19]);                          /*  HELP            */
  si_select_package(VVtemp[4]);
  cl_import(1, VVtemp[5]);
}
